SystemOrganization addCategory: #'Multilingual-Display'!

AbstractFont subclass: #FixedFaceFont
	instanceVariableNames: 'baseFont substitutionCharacter displaySelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!FixedFaceFont commentStamp: 'tak 12/22/2004 01:45' prior: 0!
I am a font for special purpose like password or fallback.
I can show same form whenever someone requests any character.

Variable displaySelector is future use to show a form dynamically.
(Although it would be unnecessary...)!

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:58'!
ascent
	^baseFont ascent! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:57'!
baseFont
	^baseFont! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:57'!
baseFont: aFont
	baseFont := aFont! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:59'!
baseKern
	^baseFont baseKern! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'tak 12/22/2004 02:01'!
characterFormAt: character 
	^ baseFont characterFormAt: substitutionCharacter! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 17:00'!
descent
	^baseFont descent! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:58'!
descentKern
	^baseFont descentKern! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'tak 12/20/2004 18:06'!
displayErrorOn: aCanvas length: length at: aPoint kern: kernDelta 
	| maskedString |
	maskedString := String new: length.
	maskedString atAllPut: substitutionCharacter.
	^ baseFont
		displayString: maskedString
		on: aCanvas
		from: 1
		to: length
		at: aPoint
		kern: kernDelta! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'yo 1/7/2005 11:49'!
displayErrorOn: aCanvas length: length at: aPoint kern: kernDelta baselineY: baselineY
	| maskedString |
	maskedString := String new: length.
	maskedString atAllPut: substitutionCharacter.
	^ baseFont
		displayString: maskedString
		on: aCanvas
		from: 1
		to: length
		at: aPoint
		kern: kernDelta
		baselineY: baselineY! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'tak 12/20/2004 18:06'!
displayPasswordOn: aCanvas length: length at: aPoint kern: kernDelta 
	| maskedString |
	maskedString := String new: length.
	maskedString atAllPut: substitutionCharacter.
	^ baseFont
		displayString: maskedString
		on: aCanvas
		from: 1
		to: length
		at: aPoint
		kern: kernDelta! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'yo 1/7/2005 11:50'!
displayPasswordOn: aCanvas length: length at: aPoint kern: kernDelta baselineY: baselineY
	| maskedString |
	maskedString := String new: length.
	maskedString atAllPut: substitutionCharacter.
	^ baseFont
		displayString: maskedString
		on: aCanvas
		from: 1
		to: length
		at: aPoint
		kern: kernDelta
		baselineY: baselineY! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'yo 1/7/2005 12:00'!
displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta 
	| size |
	size := stopIndex - startIndex + 1.
	^ self perform: displaySelector withArguments: (Array with: aDisplayContext with: size with: aPoint with: kernDelta with: aPoint y + self ascent).! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'yo 1/7/2005 12:19'!
displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY
	| size |
	size := stopIndex - startIndex + 1.
	^ self perform: displaySelector withArguments: (Array with: aDisplayContext with: size with: aPoint with: kernDelta with: baselineY).! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'tak 12/20/2004 11:10'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta from: fromFont 
	| destPoint |
	destPoint := self
				displayString: aString
				on: aBitBlt
				from: startIndex
				to: stopIndex
				at: aPoint
				kern: kernDelta.
	^ Array with: stopIndex + 1 with: destPoint! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'yo 1/7/2005 11:51'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta from: fromFont baselineY: baselineY
	| destPoint |
	destPoint := self
				displayString: aString
				on: aBitBlt
				from: startIndex
				to: stopIndex
				at: aPoint
				kern: kernDelta
				baselineY: baselineY.
	^ Array with: stopIndex + 1 with: destPoint! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'tak 12/20/2004 10:10'!
emphasized: emph
	^self class new baseFont: (baseFont emphasized: emph)! !

!FixedFaceFont methodsFor: 'initialization' stamp: 'yo 1/7/2005 11:59'!
errorFont
	displaySelector := #displayErrorOn:length:at:kern:baselineY:.
	substitutionCharacter := $?.! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'nk 8/31/2004 09:25'!
familyName
	^baseFont familyName, '-pw'! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'tak 12/20/2004 10:19'!
fontSize: aNumber 
	self baseFont: (StrikeFont familyName: baseFont familyName size: aNumber) copy! !

!FixedFaceFont methodsFor: 'private' stamp: 'yo 1/11/2005 18:54'!
glyphInfoOf: aCharacter into: glyphInfoArray

	^ baseFont glyphInfoOf: substitutionCharacter into: glyphInfoArray.
! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:57'!
height
	^baseFont height! !

!FixedFaceFont methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 09:54'!
initialize
	super initialize.
	baseFont := TextStyle defaultFont.
	self passwordFont! !

!FixedFaceFont methodsFor: 'displaying' stamp: 'ar 1/5/2003 17:00'!
installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor
	^baseFont installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'nk 8/31/2004 09:26'!
lineGrid
	^baseFont lineGrid! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'tak 12/20/2004 10:51'!
maxAscii
	^ SmallInteger maxVal! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'ar 1/5/2003 16:59'!
passwordCharacter
	^$*! !

!FixedFaceFont methodsFor: 'initialization' stamp: 'yo 1/7/2005 11:59'!
passwordFont
	displaySelector := #displayPasswordOn:length:at:kern:baselineY:.
	substitutionCharacter := $*! !

!FixedFaceFont methodsFor: 'accessing' stamp: 'nk 8/31/2004 09:28'!
pointSize
	^baseFont pointSize! !

!FixedFaceFont methodsFor: 'caching' stamp: 'nk 3/15/2004 18:48'!
releaseCachedState
	baseFont releaseCachedState.! !

!FixedFaceFont methodsFor: 'measuring' stamp: 'tak 12/20/2004 18:05'!
widthOf: aCharacter 
	^ baseFont widthOf: substitutionCharacter! !

TTFontReader subclass: #TTCFontReader
	instanceVariableNames: 'fonts'
	classVariableNames: 'EncodingTag'
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!TTCFontReader class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
encodingTag: aNumber
"
	TTCFontReader encodingTag: 6
"

	EncodingTag := aNumber.
! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
decodeCmapFmtTable: entry
	| cmapFmt length entryCount segCount segments offset cmap firstCode |
	cmapFmt := entry nextUShort.
	length := entry nextUShort.
	entry skip: 2. "skip version"

	cmapFmt = 0 ifTrue: "byte encoded table"
		[length := length - 6. 		"should be always 256"
		length <= 0 ifTrue: [^ nil].	"but sometimes, this table is empty"
		cmap := Array new: length.
		entry nextBytes: length into: cmap startingAt: entry offset.
		^ cmap].

	cmapFmt = 4 ifTrue: "segment mapping to deltavalues"
		[segCount := entry nextUShort // 2.
		entry skip: 6. "skip searchRange, entrySelector, rangeShift"
		segments := Array new: segCount.
		segments := (1 to: segCount) collect: [:e | Array new: 4].
		1 to: segCount do: [:i | (segments at: i) at: 2 put: entry nextUShort]. "endCount"
		entry skip: 2. "skip reservedPad"
		1 to: segCount do: [:i | (segments at: i) at: 1 put: entry nextUShort]. "startCount"
		1 to: segCount do: [:i | (segments at: i) at: 3 put: entry nextShort]. "idDelta"
		offset := entry offset.
		1 to: segCount do: [:i | (segments at: i) at: 4 put: entry nextUShort]. "idRangeOffset"
		cmap := Array new: 65536 withAll: 0.
		segments withIndexDo:
			[:seg :si | | code |
			seg first to: seg second do:
				[:i |
					seg last > 0 ifTrue:
						["offset to glypthIdArray - this is really C-magic!!"
						entry offset: i - seg first - 1 * 2 + seg last + si + si + offset.
						code := entry nextUShort.
						code > 0 ifTrue: [code := code + seg third]]
					ifFalse:
						["simple offset"
						code := i + seg third].
					cmap at: i + 1 put: (code \\ 16r10000)]].
		^ cmap].

	cmapFmt = 6 ifTrue: "trimmed table"
		[firstCode := entry nextUShort.
		entryCount := entry nextUShort.
		cmap := Array new: entryCount + firstCode withAll: 0.
		entryCount timesRepeat:
			[cmap at: (firstCode := firstCode + 1) put: entry nextUShort].
		^ cmap].
	^ nil! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
getTableDirEntry: tagString from: fontData offset: offset
	"Find the table named tagString in fontData and return a table directory entry for it."

	| nTables pos currentTag tag |
	nTables := fontData shortAt: 5 + offset bigEndian: true.
	tag := ByteArray new: 4.
	1 to: 4 do:[:i| tag byteAt: i put: (tagString at: i) asInteger].
	tag := tag longAt: 1 bigEndian: true.
	pos := 13 + offset.
	1 to: nTables do:[:i|
		currentTag := fontData longAt: pos bigEndian: true.
		currentTag = tag ifTrue:[^TTFontTableDirEntry on: fontData at: pos].
		pos := pos+16].
	^nil! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
parseTTCHeaderFrom: fontData

	| pos nTables |
	nTables := fontData longAt: 9 bigEndian: true.
	fonts := Array new: nTables.
	pos := 13.
	1 to: nTables do: [:i |
		fonts at: i put: (fontData longAt: pos bigEndian: true).
		pos := pos + 4.
	].

	^ fonts
! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
processCharMap: assoc
	"Process the given character map"

	| glyph cmap encode0 encode1 char value null |
	cmap := assoc value.
	null := (glyphs at: (cmap at: Character space asUnicode + 1) + 1) copy.
	null contours: #().

	encode0 := Array new: 256 withAll: glyphs first.
	encode1 := Array new: 65536 withAll: glyphs first.

	0 to: 255 do: [:i |
		char := Character value: i.
		glyph := glyphs at: (cmap at: char asUnicode + 1) + 1.
		encode0 at: i+1 put: glyph.
	].
	Character separators do: [:c |
		encode0 at: (c asciiValue + 1) put: null.
	].
	0 to: 65536 - 1 do: [:i |
		value := cmap at: i+1.
		value = 65535 ifFalse: [ "???"
			encode1 at: i+1 put: (glyphs at: value+1).
		]
	].

	^ {encode0. encode1}.
! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
processCharacterMappingTable: entry
	"Read the font's character to glyph index mapping table.
	If an appropriate mapping can be found then return an association
	with the format identifier and the contents of the table"
	| copy initialOffset nSubTables pID sID offset cmap assoc |
	initialOffset := entry offset.
	entry skip: 2. "Skip table version"
	nSubTables := entry nextUShort.
	1 to: nSubTables do:[:i|
		pID := entry nextUShort.
		sID := entry nextUShort.
		offset := entry nextULong.
		"Check if this is either a Macintosh encoded table
		or a Windows encoded table"
		(pID = 1 or:[pID = 3]) ifTrue:[
			"Go to the beginning of the table"
			copy := entry copy.
			copy offset: initialOffset + offset.
			cmap := self decodeCmapFmtTable: copy.
			"(pID = 1 and: [cmap notNil])" "Prefer Macintosh encoding over everything else"
				"ifTrue: [pID -> cmap]."
			assoc := pID -> cmap. "Keep it in case we don't find a Mac encoded table"
		].
	].
	^assoc! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
readFrom: aStream

	"Read the raw font byte data"
	| fontData |
	(aStream respondsTo: #binary) ifTrue:[aStream binary].
	fontData := aStream contents asByteArray.

	fonts := self parseTTCHeaderFrom: fontData.
	^ ((Array with: fonts first) collect: [:offset |
		fontDescription := TTCFontDescription new.
		self readFrom: fontData fromOffset: offset at: EncodingTag.
	]) at: 1.
! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'GabrielOmarCotelli 5/25/2010 21:22'!
readFrom: fontData fromOffset: offset at: encodingTag
	| headerEntry maxProfileEntry nameEntry indexLocEntry charMapEntry glyphEntry horzHeaderEntry horzMetricsEntry kerningEntry glyphOffset cmap numHMetrics indexToLocFormat fontDescription0 fontDescription1 array result |
	"Search the tables required to build the font"
	(headerEntry := self getTableDirEntry: 'head' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a header table' ].
	(maxProfileEntry := self getTableDirEntry: 'maxp' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a maximum profile table' ].
	(nameEntry := self getTableDirEntry: 'name' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a name table' ].
	(indexLocEntry := self getTableDirEntry: 'loca' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a relocation table' ].
	(charMapEntry := self getTableDirEntry: 'cmap' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a character map table' ].
	(glyphEntry := self getTableDirEntry: 'glyf' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a glyph table' ].
	(horzHeaderEntry := self getTableDirEntry: 'hhea' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a horizontal header table' ].
	(horzMetricsEntry := self getTableDirEntry: 'hmtx' from: fontData offset: offset) == nil
		ifTrue: [ ^ self error: 'This font does not have a horizontal metrics table' ].
	(kerningEntry := self getTableDirEntry: 'kern' from: fontData offset: offset) == nil
		ifTrue: [ 
			Transcript
				cr;
				show: 'This font does not have a kerning table';
				endEntry ].	"Process the data"
	indexToLocFormat := self processFontHeaderTable: headerEntry.
	self processMaximumProfileTable: maxProfileEntry.
	self processNamingTable: nameEntry.
	glyphOffset := self processIndexToLocationTable: indexLocEntry format: indexToLocFormat.
	cmap := self processCharacterMappingTable: charMapEntry.
	(cmap == nil or: [ cmap value == nil ])
		ifTrue: [ ^ self error: 'This font has no suitable character mappings' ].
	self processGlyphDataTable: glyphEntry offsets: glyphOffset.
	numHMetrics := self processHorizontalHeaderTable: horzHeaderEntry.
	self processHorizontalMetricsTable: horzMetricsEntry length: numHMetrics.
	kerningEntry isNil
		ifTrue: [ kernPairs := #() ]
		ifFalse: [ self processKerningTable: kerningEntry ].
	array := self processCharMap: cmap.
	fontDescription0 := fontDescription shallowCopy.
	fontDescription1 := fontDescription shallowCopy.
	fontDescription0 setGlyphs: (array at: 1) mapping: nil.
	fontDescription1 setGlyphs: (array at: 2) mapping: nil.	"fontDescription setKernPairs: kernPairs."
	result := OrderedCollection new.
	(encodingTag isNil or: [ encodingTag = 0 ])
		ifTrue: [ ^ Array with: fontDescription1 ].
	result add: fontDescription0.
	encodingTag - 1 timesRepeat: [ result add: nil ].
	result add: fontDescription1.
	^ result asArray! !

!TTCFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
readTTFFrom: aStream

	"Read the raw font byte data"
	| fontData |
	(aStream respondsTo: #binary) ifTrue:[aStream binary].
	fontData := aStream contents asByteArray.
	fontDescription := TTCFontDescription new.

	^ self readFrom: fontData fromOffset: 0 at: EncodingTag.
! !

AbstractFont subclass: #StrikeFontSet
	instanceVariableNames: 'fontArray emphasis derivativeFonts name'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Multilingual-Display'!

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
createExternalFontFileForLatin2: fileName
	"
	StrikeFontSet createExternalFontFileForLatin2: 'latin2.out'.
"

	| file array f installDirectory |
	file := FileStream newFileNamed: fileName.
	installDirectory := Smalltalk globals at: #M17nInstallDirectory ifAbsent: [  ].
	installDirectory := installDirectory
		ifNil: [ String new ]
		ifNotNil: [ installDirectory , FileDirectory pathNameDelimiter asString ].
	array := Array
		with:
			(StrikeFont
				newFromEFontBDFFile: installDirectory , 'b10.bdf'
				name: 'LatinTwo9'
				ranges: EFontBDFFontReaderForRanges rangesForLatin2)
		with:
			(StrikeFont
				newFromEFontBDFFile: installDirectory , 'b12.bdf'
				name: 'LatinTwo10'
				ranges: EFontBDFFontReaderForRanges rangesForLatin2)
		with:
			(StrikeFont
				newFromEFontBDFFile: installDirectory , 'b14.bdf'
				name: 'LatinTwo12'
				ranges: EFontBDFFontReaderForRanges rangesForLatin2)
		with:
			(StrikeFont
				newFromEFontBDFFile: installDirectory , 'b16.bdf'
				name: 'LatingTwo14'
				ranges: EFontBDFFontReaderForRanges rangesForLatin2)
		with:
			(StrikeFont
				newFromEFontBDFFile: installDirectory , 'b24.bdf'
				name: 'LatinTwo20'
				ranges: EFontBDFFontReaderForRanges rangesForLatin2).
	TextSharedInformation at: #forceFontWriting put: true.
	f := ReferenceStream on: file.
	f nextPut: array.
	file close.
	TextSharedInformation removeKey: #forceFontWriting! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
createExternalFontFileForUnicodeJapanese: fileName
	"
	StrikeFontSet createExternalFontFileForUnicodeJapanese: 'uJapaneseFont.out'.
"

	| file array f installDirectory |
	file := FileStream newFileNamed: fileName.
	installDirectory := Smalltalk globals at: #M17nInstallDirectory ifAbsent: [  ].
	installDirectory := installDirectory
		ifNil: [ String new ]
		ifNotNil: [ installDirectory , FileDirectory pathNameDelimiter asString ].
	array := Array
		with:
			(StrikeFont newForJapaneseFromEFontBDFFile: installDirectory , 'b12.bdf' name: 'Japanese10' overrideWith: 'shnmk12.bdf')
		with:
			(StrikeFont newForJapaneseFromEFontBDFFile: installDirectory , 'b14.bdf' name: 'Japanese12' overrideWith: 'shnmk14.bdf')
		with: (StrikeFont newForJapaneseFromEFontBDFFile: 'b16.bdf' name: 'Japanese14' overrideWith: 'shnmk16.bdf')
		with:
			(StrikeFont newForJapaneseFromEFontBDFFile: installDirectory , 'b24.bdf' name: 'Japanese18' overrideWith: 'kanji24.bdf').	"fixAscent: 14 andDescent: 1 head: 1"	"fixAscent: 16 andDescent: 4 head: 4"
	TextSharedInformation at: #forceFontWriting put: true.
	f := ReferenceStream on: file.
	f nextPut: array.
	file close.
	TextSharedInformation removeKey: #forceFontWriting! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
createExternalFontFileForUnicodeKorean: fileName
	"
	Smalltalk garbageCollect.
	StrikeFontSet createExternalFontFileForUnicodeKorean: 'uKoreanFont.out'.
"

	| file array f installDirectory |
	file := FileStream newFileNamed: fileName.
	installDirectory := Smalltalk globals at: #M17nInstallDirectory ifAbsent: [  ].
	installDirectory := installDirectory
		ifNil: [ String new ]
		ifNotNil: [ installDirectory , FileDirectory pathNameDelimiter asString ].
	array := Array
		with:
			(StrikeFont newForKoreanFromEFontBDFFile: installDirectory , 'b12.bdf' name: 'Korean10' overrideWith: 'shnmk12.bdf')
		with:
			(StrikeFont newForKoreanFromEFontBDFFile: installDirectory , 'b14.bdf' name: 'Korean12' overrideWith: 'shnmk14.bdf')
		with:
			((StrikeFont newForKoreanFromEFontBDFFile: installDirectory , 'b16.bdf' name: 'Korean14' overrideWith: 'hanglg16.bdf')
				fixAscent: 16
				andDescent: 4
				head: 4)
		with:
			(StrikeFont newForKoreanFromEFontBDFFile: installDirectory , 'b24.bdf' name: 'Korean18' overrideWith: 'hanglm24.bdf').	"fixAscent: 14 andDescent: 1 head: 1"
	TextSharedInformation at: #forceFontWriting put: true.
	f := ReferenceStream on: file.
	f nextPut: array.
	file close.
	TextSharedInformation removeKey: #forceFontWriting! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
decodedFromRemoteCanvas: aString

	| array |
	array := aString findTokens: #($ ).
	^ self familyName: (array at: 1) size: (array at: 2) asNumber emphasized: (array at: 3) asNumber.
! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
duplicateArrayElementsForLeadingCharShift
"
	self duplicateArrayElementsForLeadingCharShift
"
	
	self allInstances do: [:s | | array font |
		s emphasis = 0 ifTrue: [
			array := s fontArray.
			2 to: (4 min: array size) do: [:i |
				font := array at: i.
				s addNewFont: font at: ((i - 1) << 2) + 1.
			].
		] ifFalse: [
			s reset
		].
	].
! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
familyName: aName size: aSize
	"Answer a font (or the default font if the name is unknown) in the specified size."

	| collection |
	collection :=  self allInstances select: [:inst | (inst name beginsWith: aName) and: [inst emphasis = 0]].
	collection isEmpty ifTrue: [
		(aName = 'DefaultMultiStyle') ifTrue: [
			collection := (TextSharedInformation at: #DefaultMultiStyle) fontArray.
		] ifFalse: [
			^ TextStyle defaultFont
		]
	].
	collection := collection asSortedCollection: [:a :b | a pointSize <= b pointSize].
	collection do: [:s | (s pointSize >= aSize) ifTrue: [^ s]].
	^ TextStyle defaultFont.
! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 8/18/2003 21:03'!
familyName: aName size: aSize emphasized: emphasisCode
	"Create the font with this emphasis"

	^ (self familyName: aName size: aSize) emphasized: emphasisCode
! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 5/25/2004 14:32'!
findMaximumLessThan: f in: array

	array size to: 1 by: -1 do: [:i |
		f height >= (array at: i) height ifTrue: [^ array at: i].
	].
	^ array first.
! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'yo 1/18/2005 16:00'!
installExternalFontFileName6: fileName encoding: encoding encodingName: aString textStyleName: styleName

	^ self installExternalFontFileName6: fileName inDir: FileDirectory default encoding: encoding encodingName: aString textStyleName: styleName.

"
StrikeFontSet createExternalFontFileForCyrillic: 'cyrillicFont.out'.

StrikeFontSet installExternalFontFileName6: 'latin2.out' encoding: Latin2Environment leadingChar encodingName: #Latin2 textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName6: 'uJapaneseFont.out' encoding: JapaneseEnvironment leadingChar encodingName: #Japanese textStyleName: #DefaultMultiStyle.

StrikeFontSet installExternalFontFileName6: 'uKoreanFont.out' encoding: UnicodeKorean leadingChar encodingName: #Korean textStyleName: #DefaultMultiStyle.

StrikeFontSet removeFontsForEncoding: 2 encodingName: #Gb2312.
self halt.
StrikeFontSet removeFontsForEncoding: 3 encodingName: #KsX1001.
"
! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'tak 8/3/2005 17:40'!
installExternalFontFileName6: fileName inDir: dir encoding: encoding encodingName: aString textStyleName: styleName 
	| aStream |
	aStream := dir readOnlyFileNamed: fileName.
	[self
		installExternalFontOn: aStream
		encoding: encoding
		encodingName: aString
		textStyleName: styleName]
		ensure: [aStream close]! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'yo 3/17/2004 10:32'!
installExternalFontFileName: fileName encoding: encoding encodingName: aString textStyleName: styleName

	^ self installExternalFontFileName: fileName inDir: FileDirectory default encoding: encoding encodingName: aString textStyleName: styleName.

"
StrikeFontSet createExternalFontFileForCyrillic: 'cyrillicFont.out'.

StrikeFontSet installExternalFontFileName: 'chineseFont.out' encoding: 2 encodingName: #Gb2312 textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'japaneseFont.out' encoding: 1 encodingName: #JisX0208 textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'defaultFont.out' encoding: 0 encodingName: #Latin1 textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'cyrillicFont.out' encoding: UnicodeCyrillic leadingChar encodingName: #Cyrillic textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'extendedLatinFont.out' encoding: UnicodeLatinExtendedAB leadingChar encodingName: #ExtendedLatin textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'ipaExtensionsFont.out' encoding: UnicodeIPA leadingChar encodingName: #IPAExtensions textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'armenianFont.out' encoding: UnicodeArmenian leadingChar encodingName: #Armenian textStyleName: #DefaultMultiStyle.
StrikeFontSet installExternalFontFileName: 'greekFont.out' encoding: UnicodeGreek leadingChar encodingName: #Greek textStyleName: #DefaultMultiStyle.

StrikeFontSet installExternalFontFileName: 'arrowFont.out' encoding: UnicodeArrows leadingChar encodingName: #Arrow textStyleName: #DefaultMultiStyle.

StrikeFontSet installExternalFontFileName: 'uJapaneseFont.out' indir: FileDirectory default encoding: JapaneseEnvironment leadingChar encodingName: #Japanese textStyleName: #DefaultMultiStyle.

StrikeFontSet installExternalFontFileName: 'uKoreanFont.out' encoding: UnicodeKorean leadingChar encodingName: #Korean textStyleName: #DefaultMultiStyle.

StrikeFontSet removeFontsForEncoding: 2 encodingName: #Gb2312.
self halt.
StrikeFontSet removeFontsForEncoding: 3 encodingName: #KsX1001.
"
! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
installExternalFontFileName: fileName inDir: dir encoding: encoding encodingName: aString textStyleName: styleName

	| array arrayFour oldStyle arrayOfFS |
	array := (ReferenceStream on: (dir readOnlyFileNamed: fileName)) next.

	arrayFour := Array new: 4 withAll: array last.
	arrayFour replaceFrom: 1 to: array size with: array startingAt: 1.
	TextSharedInformation at: aString asSymbol put: arrayFour.

	oldStyle := TextSharedInformation at: styleName asSymbol.
	arrayOfFS := oldStyle fontArray.
	arrayOfFS := (1 to: 4) collect: [:i | | fs fonts newFonts |
		fs := arrayOfFS at: i.
		fonts := fs fontArray.
		encoding + 1 > fonts size ifTrue: [
			newFonts := Array new: encoding + 1.
			newFonts replaceFrom: 1 to: fonts size with: fonts startingAt: 1.
			newFonts at: encoding + 1 put: (arrayFour at: i).
			fs initializeWithFontArray: newFonts.
		] ifFalse: [
			fonts at: encoding + 1 put: (arrayFour at: i).
		].
		fs.
	].

	TextSharedInformation at: styleName asSymbol put: (TextStyle fontArray: arrayOfFS).
	oldStyle becomeForward: (TextSharedInformation at: styleName asSymbol).

! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
installExternalFontOn: aStream encoding: encoding encodingName: aString textStyleName: styleName

	| array encodingIndex textStyle |

	array := aStream
		untilEndWithFork: [(ReferenceStream on: aStream) next]
		displayingProgress: 'Font reading...'. 
	
	TextSharedInformation at: aString asSymbol put: array.

	textStyle := TextSharedInformation at: styleName asSymbol.
	encodingIndex := encoding + 1.
	textStyle fontArray do: [:fs | | fonts |
		fonts := fs fontArray.
		encodingIndex > fonts size
			ifTrue: [fonts :=  (Array new: encodingIndex)
				replaceFrom: 1 to: fonts size with: fonts startingAt: 1].
		fonts at: encodingIndex put: (self findMaximumLessThan: fs fontArray first in: array).
		fs initializeWithFontArray: fonts.
	].
! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'tak 8/4/2005 11:03'!
installExternalFontOn: aStream forLocale: locale 
	self
		installExternalFontOn: aStream
		encoding: locale languageEnvironment leadingChar
		encodingName: locale languageEnvironment fontEncodingName
		textStyleName: #DefaultMultiStyle! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'nice 1/5/2010 15:59'!
installNewFontAtIndex: newIndex fromOld: oldIndex

	
	self allInstances do: [:set | | newArray fontArray |
		fontArray := set fontArray.
		newIndex + 1 > fontArray size ifTrue: [
			newArray := Array new: newIndex + 1.
			newArray replaceFrom: 1 to: fontArray size with: fontArray startingAt: 1.
			newArray at: newIndex + 1 put: (fontArray at: oldIndex + 1).
			set initializeWithFontArray: newArray.
		] ifFalse: [
			fontArray at: newIndex + 1 put: (fontArray at: oldIndex + 1).
		].
	].

"
StrikeFontSet installNewFontAtIndex: UnicodeSimplifiedChinese leadingChar fromOld: UnicodeJapanese leadingChar
StrikeFontSet installNewFontAtIndex: UnicodeKorean leadingChar fromOld: UnicodeJapanese leadingChar
"
! !

!StrikeFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 9/23/2002 16:32'!
newFontArray: anArray
 
	^super new initializeWithFontArray: anArray
! !

!StrikeFontSet class methodsFor: 'filein/out' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
removeFontsForEncoding: leadingChar encodingName: encodingSymbol

	| insts |
	leadingChar = 0 ifTrue: [^ self error: 'you cannot delete the intrinsic fonts'].
	insts := self allInstances.
	insts do: [:inst | | index fonts newFonts |
		fonts := inst fontArray.
		fonts size >= (leadingChar + 1) ifTrue: [
			leadingChar + 1 = fonts size ifTrue: [
				newFonts := fonts copyFrom: 1 to: fonts size - 1.
				index := newFonts indexOf: nil.
				index > 0 ifTrue: [newFonts := newFonts copyFrom: 1 to: index - 1].
				inst initializeWithFontArray: newFonts.
			] ifFalse: [
				fonts at: leadingChar + 1 put: nil.
			].
		].
	].

	TextSharedInformation removeKey: encodingSymbol asSymbol ifAbsent: [].
! !

!StrikeFontSet methodsFor: 'private' stamp: 'sd 2/4/2008 21:13'!
addNewFont: aFont at: encodingIndex

	| newArray |
	encodingIndex > fontArray size ifTrue: [
		newArray := Array new: encodingIndex.
		newArray replaceFrom: 1 to: fontArray size with: fontArray startingAt: 1.
	] ifFalse: [
		newArray := fontArray.
	].

	newArray at: encodingIndex put: aFont.

	self initializeWithFontArray: newArray.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:14'!
ascent

	^ (fontArray  at: 1) ascent.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:14'!
ascentKern

	^ (fontArray  at: 1) ascentKern.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'ar 4/12/2005 17:14'!
ascentOf: aCharacter
	^(self fontOf: aCharacter) ascent! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:14'!
baseKern

	^ (fontArray  at: 1) baseKern.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
bonk: glyphForm with: bonkForm at: j
	"Bonking means to run through the glyphs clearing out black pixels
	between characters to prevent them from straying into an adjacent
	character as a result of, eg, bolding or italicizing"
	"Uses the bonkForm to erase at every character boundary in glyphs."

	| bb offset font x |
	font := (fontArray at: j).
	offset := bonkForm offset x.
	bb := BitBlt toForm: glyphForm.
	bb sourceForm: bonkForm; sourceRect: bonkForm boundingBox;
		combinationRule: Form erase; destY: 0.
	x := font xTable.
	(x isMemberOf: SparseLargeTable) ifTrue: [
		x base to: x size-1 do: [:i | bb destX: (x at: i) + offset; copyBits].
	] ifFalse: [
		1 to: x size-1 do: [:i | bb destX: (x at: i) + offset; copyBits].
	].
! !

!StrikeFontSet methodsFor: 'character shapes' stamp: 'sd 2/4/2008 21:20'!
characterFormAt: character 

	| encoding ascii xTable leftX rightX |
	encoding := character leadingChar + 1.
	ascii := character charCode.
	(ascii < (fontArray at: encoding) minAscii or: [ascii > (fontArray at: encoding) maxAscii])
		ifTrue: [ascii := (fontArray at: encoding) maxAscii].
	xTable := (fontArray at: encoding) xTable.
	leftX := xTable at: ascii + 1.
	rightX := xTable at: ascii + 2.
	^ (fontArray at: encoding) glyphs copy: (leftX @ 0 corner: rightX @ self height).
! !

!StrikeFontSet methodsFor: 'character shapes' stamp: 'sd 2/4/2008 21:20'!
characterFormAt: character put: characterForm 

	| ascii leftX rightX widthDif newGlyphs encoding xTable glyphs |
	encoding := character leadingChar + 1.
	ascii := character charCode.
	ascii < (fontArray at: encoding) minAscii ifTrue: [
		^ self error: 'Cant store characters below min ascii'
	].
	ascii > (fontArray at: encoding) maxAscii ifTrue: [
		^ self error: 'No change made'
	].
	xTable := (fontArray at: encoding) xTable.
	leftX := xTable at: ascii + 1.
	rightX := xTable at: ascii + 2.
	glyphs := (fontArray at: encoding) glyphs.
	widthDif := characterForm width - (rightX - leftX).
	widthDif ~= 0 ifTrue: [
		newGlyphs := Form extent: glyphs width + widthDif @ glyphs height.
		newGlyphs copy: (0 @ 0 corner: leftX @ glyphs height) from: 0 @ 0
			in: glyphs rule: Form over.
		newGlyphs
				copy: (rightX + widthDif @ 0 corner: newGlyphs width @ glyphs height)
				from: rightX @ 0 in: glyphs rule: Form over.
		glyphs := newGlyphs.
		"adjust further entries on xTable"
		xTable := xTable copy.
		ascii + 2 to: xTable size do: [:i |
			xTable at: i put: (xTable at: i) + widthDif]].
	glyphs copy: (leftX @ 0 extent: characterForm extent) from: 0 @ 0 in: characterForm rule: Form over.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'IgorStasenko 4/19/2009 14:51'!
characterToGlyphMap
	"used in 
	primDisplayString: aString from: startIndex to: stopIndex
			map: font characterToGlyphMap xTable: font xTable
			kern: kernDelta.
	
	Since 'font xTable' using a first font xtable, we could use the same glyph mapping for it'
	
	This should allow a primitive to not fail, because of characterToGlyphMap == nil
	"
	^ (fontArray at: 1) characterToGlyphMap! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'nice 1/10/2010 15:06'!
characters: anInterval in: sourceString displayAt: aPoint clippedBy: clippingRectangle rule: ruleInteger fillColor: aForm kernDelta: kernDelta on: aBitBlt
	"Simple, slow, primitive method for displaying a line of characters.
	No wrap-around is provided."

	^anInterval inject: aPoint into: 
		[:destPoint :i |
		| f xTable leftX noFont sourceRect encoding ascii rightX |
		encoding := (sourceString at: i) leadingChar + 1.
		noFont := false.
		f := [fontArray at: encoding]
			on: Exception do: [:ex | nil].
		f ifNil: [noFont := true. f := fontArray at: 1].
		ascii := (noFont ifTrue: [$?] ifFalse: [sourceString at: i]) charCode.
		(ascii < f minAscii
			or: [ascii > f maxAscii])
			ifTrue: [ascii := f maxAscii].
		xTable := f xTable.
		leftX := xTable at: ascii + 1.
		rightX := xTable at: ascii + 2.
		sourceRect := leftX @ 0 extent: (rightX - leftX) @ self height.
		aBitBlt copyFrom: sourceRect in: f glyphs to: destPoint.
		destPoint x + (rightX - leftX + kernDelta) @ destPoint y.
	].
! !

!StrikeFontSet methodsFor: 'copying' stamp: 'sd 2/4/2008 21:20'!
copy

	| s a |
	s := self class new.
	s name: self name.
	s emphasis: self emphasis.
	s reset.
	a := Array new: fontArray size.
	1 to: a size do: [:i |
		a at: i put: (fontArray at: i) copy.
	].
	s fontArray: a.
	^ s.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'nk 9/1/2004 12:06'!
derivativeFonts
	^derivativeFonts copyWithout: nil! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:14'!
descent

	^ (fontArray  at: 1) descent.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:10'!
descentKern

	^ (fontArray at: 1) descentKern.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'ar 4/12/2005 17:15'!
descentOf: aCharacter
	^(self fontOf: aCharacter) descent! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 5/19/2004 11:36'!
displayLine: aString at: aPoint 
	"Display the characters in aString, starting at position aPoint."

	self characters: (1 to: aString size)
		in: aString
		displayAt: aPoint
		clippedBy: Display boundingBox
		rule: Form over
		fillColor: nil
		kernDelta: 0
		on: (BitBlt current toForm: Display).
! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'nice 1/10/2010 15:07'!
displayMultiString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY

	| destPoint leftX rightX glyphInfo g destY |
	destPoint := aPoint.
	glyphInfo := Array new: 5.
	startIndex to: stopIndex do: [:charIndex |
		self glyphInfoOf: (aString at: charIndex) into: glyphInfo.
		g := glyphInfo at:1.
		leftX := glyphInfo at:2.
		rightX := glyphInfo at:3.
		((glyphInfo at:5) ~= aBitBlt lastFont) ifTrue: [
			(glyphInfo at:5) installOn: aBitBlt.
		].
		aBitBlt sourceForm: g.
		destY := baselineY - (glyphInfo at:4).
		aBitBlt destX: (destPoint x) destY: destY width: (rightX - leftX) height: (self height).
		aBitBlt sourceOrigin: leftX @ 0.
		aBitBlt copyBits.
		destPoint := destPoint x + (rightX - leftX + kernDelta) @ destPoint y.
	].
	^ destPoint.! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'yo 1/7/2005 12:04'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta 

	^ self displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: aPoint y + self ascent.
! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'HenrikSperreJohansen 9/1/2009 00:40'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY
	"Draw the given string from startIndex to stopIndex 
	at aPoint on the (already prepared) BitBlt."
	
	"Look for an excuse to use the fast primitive"
 	(aString hasWideCharacterFrom: startIndex to: stopIndex) ifTrue:[
		^ self displayMultiString: aString 
				on: aBitBlt 
				from: startIndex 
				to: stopIndex 
				at: aPoint 
				kern: kernDelta 
				baselineY: baselineY].

	^ aBitBlt displayString: aString 
			from: startIndex 
			to: stopIndex 
			at: aPoint 
			strikeFont: self
			kern: kernDelta! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'StephaneDucasse 10/2/2010 16:56'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta from: fromFont baselineY: baselineY

	| destPoint leftX rightX glyphInfo g tag char destY rIndex| 
	destPoint := aPoint.
	rIndex := startIndex.
	tag := (aString at: rIndex) leadingChar.
	glyphInfo := Array new: 5.
	[rIndex <= stopIndex] whileTrue: [
		char := aString at: rIndex.
		((fromFont hasGlyphOf: char) or: [char leadingChar ~= tag]) ifTrue: [^ Array with: rIndex with: destPoint].
		self glyphInfoOf: char into: glyphInfo.
		g := glyphInfo at: 1.
		leftX := glyphInfo at: 2.
		rightX := glyphInfo at: 3.
		(glyphInfo fifth ~= aBitBlt lastFont) ifTrue: [
			glyphInfo fifth installOn: aBitBlt.
		].
		aBitBlt sourceForm: g.
		destY := baselineY - (glyphInfo at: 4). 
		aBitBlt destX: destPoint x.
		aBitBlt destY: destY.
		aBitBlt sourceOrigin: leftX @ 0.
		aBitBlt width: rightX - leftX.
		aBitBlt height: self height.
		aBitBlt copyBits.
		destPoint := destPoint + (rightX - leftX + kernDelta @ 0).
		rIndex := rIndex + 1.
	].
	^ Array with: rIndex with: destPoint.
! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'nice 1/10/2010 15:08'!
displayStringR2L: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta 

	| destPoint font |
	destPoint := aPoint.
	startIndex to: stopIndex do: [:charIndex | 
		| encoding ascii xTable leftX rightX | 
		encoding := (aString at: charIndex) leadingChar + 1.
		ascii := (aString at: charIndex) charCode.
		font := fontArray at: encoding.
		((ascii between: font minAscii and: font maxAscii) not) ifTrue: [
			ascii := font maxAscii].
		xTable := font xTable.
		leftX := xTable at: ascii + 1.
		rightX := xTable at: ascii + 2.
		aBitBlt
			sourceForm: font glyphs;
			destX: destPoint x - (rightX - leftX);
			destY: destPoint y;
			sourceOrigin: leftX @ 0;
			width: rightX - leftX;
			height: self height;
			copyBits.
		destPoint := destPoint x - (rightX - leftX + kernDelta) @ destPoint y.
	].
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 9/17/2002 17:06'!
emphasis
	"Answer the integer code for synthetic bold, italic, underline, and 
	strike-out."

	^ emphasis.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
emphasis: code 
	"Set the integer code for synthetic bold, itallic, underline, and strike-out, 
	where bold=1, italic=2, underlined=4, and struck out=8."

	emphasis := code.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'marcus.denker 9/14/2008 19:09'!
emphasized: code 

	"Answer a copy of the receiver with emphasis set to include code."
	| derivative addedEmphasis base safeCode |
	code = 0 ifTrue: [^ self].
	derivativeFonts isEmptyOrNil ifTrue: [^ self].
	derivative := derivativeFonts at: (safeCode := code min: derivativeFonts size).
	derivative ifNotNil: [^ derivative].  "Already have this style"

	"Dont have it -- derive from another with one with less emphasis"
	addedEmphasis := 1 bitShift: safeCode highBit - 1.
	base := self emphasized: safeCode - addedEmphasis.  "Order is Bold, Ital, Under, Narrow"
	addedEmphasis = 1 ifTrue:   "Compute synthetic bold version of the font"
		[derivative := (base copy name: base name , 'B') makeBoldGlyphs].
	addedEmphasis = 2 ifTrue:   "Compute synthetic italic version of the font"
		[ derivative := (base copy name: base name , 'I') makeItalicGlyphs].
	addedEmphasis = 4 ifTrue:   "Compute underlined version of the font"
		[derivative := (base copy name: base name , 'U') makeUnderlinedGlyphs].
	addedEmphasis = 8 ifTrue:   "Compute narrow version of the font"
		[derivative := (base copy name: base name , 'N') makeCondensedGlyphs].
	addedEmphasis = 16 ifTrue:   "Compute struck-out version of the font"
		[derivative := (base copy name: base name , 'X') makeStruckOutGlyphs].
	derivative emphasis: safeCode.
	derivativeFonts at: safeCode put: derivative.
	^ derivative
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:11'!
familyName

	^ (fontArray at: 1) familyName.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:11'!
familySizeFace

	^ Array
		with: (fontArray  at: 1) name
		with: self height
		with: (fontArray  at: 1) emphasis
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'yo 9/23/2002 20:08'!
fontArray

	^ fontArray
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
fontArray: anArray

	fontArray := anArray.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:12'!
fontNameWithPointSize

	^ (fontArray at: 1) fontNameWithPointSize.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'ar 4/12/2005 17:14'!
fontOf: aCharacter
	"Answer the actual font to use for aCharacter"
	^self fontOf: aCharacter ifAbsent:[fontArray at: 1]! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'ar 4/12/2005 17:14'!
fontOf: aCharacter ifAbsent: aBlock
	"Answer the actual font to use for aCharacter"
	| encoding font |
	encoding := aCharacter leadingChar + 1.
	encoding <= fontArray size 
		ifTrue:[font := fontArray at: encoding].
	font ifNil:[^aBlock value].
	^font
! !

!StrikeFontSet methodsFor: 'private' stamp: 'sd 2/4/2008 21:14'!
glyphInfoOf: aCharacter into: glyphInfoArray

	| index f code leftX |
	index := aCharacter leadingChar + 1.
	fontArray size < index ifTrue: [^ self questionGlyphInfoInto: glyphInfoArray].
	(f := fontArray at: index) ifNil: [^ self questionGlyphInfoInto: glyphInfoArray].

	code := aCharacter charCode.
	((code between: f minAscii and: f maxAscii) not) ifTrue: [
		^ self questionGlyphInfoInto: glyphInfoArray.
	].
	leftX := f xTable at: code + 1.
	leftX < 0 ifTrue: [
		^ self questionGlyphInfoInto: glyphInfoArray.
	].
	glyphInfoArray at: 1 put: f glyphs;
		at: 2 put: leftX;
		at: 3 put: (f xTable at: code + 2);
		at: 4 put: (f ascentOf: aCharacter);
		at: 5 put: self.
	^ glyphInfoArray.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:12'!
glyphs

	^ (fontArray  at: 1) glyphs
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 9/17/2002 17:50'!
glyphsEncoding: anInteger

	^ (fontArray at: (anInteger+1)) glyphs.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:12'!
height

	^ (fontArray  at: 1) height.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'ar 4/12/2005 17:15'!
heightOf: aCharacter
	^(self fontOf: aCharacter) height! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:12'!
initializeWithFontArray: anArray 
	"Initialize with given font array, the ascent of primary font is modified 
	if another font has higher size"
	| primaryFont maxHeight newFont |
	fontArray := anArray.
	primaryFont := anArray at: 1.
	emphasis := 0.
	name := primaryFont name.
	maxHeight := anArray
				inject: 0
				into: [:theHeight :font | (font notNil
							and: [theHeight < font height])
						ifTrue: [font height]
						ifFalse: [theHeight]].
	primaryFont height < maxHeight
		ifTrue: [newFont := primaryFont copy
						fixAscent: primaryFont ascent + (maxHeight - primaryFont height)
						andDescent: primaryFont descent
						head: 0.
			fontArray at: 1 put: newFont].
	self reset! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 1/5/2005 13:59'!
installOn: aDisplayContext

	^ aDisplayContext installStrikeFont: self.
! !

!StrikeFontSet methodsFor: 'displaying' stamp: 'yo 9/17/2002 17:50'!
installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor 

	^ aDisplayContext
		installStrikeFont: self
		foregroundColor: foregroundColor
		backgroundColor: backgroundColor.
! !

!StrikeFontSet methodsFor: 'testing' stamp: 'yo 2/12/2007 19:34'!
isFontSet

	^ true.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'tak 12/21/2004 16:43'!
latin1
	"Answer primary font"
	^ fontArray at: 1! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:13'!
lineGrid

	| f |
	f := fontArray at: 1.
	^ f ascent + f descent.
! !

!StrikeFontSet methodsFor: 'emphasis' stamp: 'sd 2/4/2008 21:14'!
makeBoldGlyphs
	"Make a bold set of glyphs with same widths by ORing 1 bit to the right
		(requires at least 1 pixel of intercharacter space)"

	| g bonkForm font |
	1 to: fontArray size do: [:i |
		font := fontArray at: i.
		font ifNotNil: [
			g := font glyphs deepCopy.
			bonkForm := (Form extent: 1@16) fillBlack offset: -1@0.
			self bonk: g with: bonkForm at: i.
			g copyBits: g boundingBox from: g at: (1@0)
				clippingBox: g boundingBox rule: Form under fillColor: nil.
			(fontArray at: i) setGlyphs: g.
		].
	].
! !

!StrikeFontSet methodsFor: 'emphasis' stamp: 'sd 2/4/2008 21:18'!
makeItalicGlyphs
	"Make an italic set of glyphs with same widths by skewing left and right
		(may require more intercharacter space)"

	| g bonkForm bc font |
	1 to: fontArray size do: [:j |
		font := (fontArray at: j).
		font ifNotNil: [
			g := font glyphs deepCopy.
			"BonkForm will have bits where slanted characters overlap their neighbors."
			bonkForm := Form extent: (self height//4+2) @ self height.
			bc := font descent//4 + 1.  "Bonker x-coord corresponding to char boundary."
			bonkForm fill: (0 @ 0 corner: (bc+1) @ font ascent) fillColor: Color black.
			4 to: font ascent-1 by: 4 do:
				[:y | 		"Slide ascenders right..."
				g copy: (1@0 extent: g width @ (font ascent - y))
					from: 0@0 in: g rule: Form over.
				bonkForm copy: (1@0 extent: bonkForm width @ (font ascent - y))
					from: 0@0 in: bonkForm rule: Form over].
			bonkForm fill: (0 @ 0 corner: (bc+1) @ font ascent) fillColor: Color white.
			bonkForm fill: (bc @ font ascent corner: bonkForm extent) fillColor: Color black.
			font ascent to: font height-1 by: 4 do:
				[:y | 		"Slide descenders left..."
				g copy: (0@y extent: g width @ g height)
					from: 1@y in: g rule: Form over.
				bonkForm copy: (0@0 extent: bonkForm width @ bonkForm height)
					from: 1@0 in: bonkForm rule: Form over].
			bonkForm fill: (bc @ font ascent corner: bonkForm extent) fillColor: Color white.
			"Now use bonkForm to erase at every character boundary in glyphs."
			bonkForm offset: (0-bc) @ 0.
			font bonk: g with: bonkForm.
			font setGlyphs: g
		].
	].
! !

!StrikeFontSet methodsFor: 'emphasis' stamp: 'sd 2/4/2008 21:18'!
makeStruckOutGlyphs
	"Make a struck-out set of glyphs with same widths"

	| g font |
	1 to: fontArray size do: [:i |
		font := (fontArray at: i).
		font ifNotNil: [
			g := font glyphs deepCopy.
			g fillBlack: (0 @ (font ascent - (font ascent//3)) extent: g width @ 1).
			font setGlyphs: g
		].
	].
! !

!StrikeFontSet methodsFor: 'emphasis' stamp: 'sd 2/4/2008 21:18'!
makeUnderlinedGlyphs
	"Make an underlined set of glyphs with same widths"

	| g font |
	1 to: fontArray size do: [:i |
		font := (fontArray at: i).
		font ifNotNil: [
			g := font glyphs deepCopy.
			g fillBlack: (0 @ (font ascent+1) extent: g width @ 1).
			font setGlyphs: g
		].
	].
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'sd 2/4/2008 21:20'!
maxAsciiFor: encoding

	| f |
	f := (fontArray at: encoding+1).
	f ifNotNil: [^ f maxAscii].
	^ 0.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 9/17/2002 17:52'!
maxEncoding

	^ fontArray size.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 2/24/2005 15:45'!
maxWidth

	^ (fontArray at: 1) maxWidth.
! !

!StrikeFontSet methodsFor: 'testing' stamp: 'yo 9/17/2002 17:52'!
name

	^ name
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
name: aString

	name := aString
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:13'!
pointSize

	^ (fontArray  at: 1) pointSize.
! !

!StrikeFontSet methodsFor: 'copying' stamp: 'StephaneDucasse 10/2/2010 16:57'!
postCopy
	super postCopy.
	self reset.
	fontArray := fontArray copy! !

!StrikeFontSet methodsFor: 'printing' stamp: 'yo 9/17/2002 17:53'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '(' , self name.
	aStream space.
	self height printOn: aStream.
	aStream nextPut: $).
! !

!StrikeFontSet methodsFor: 'private' stamp: 'sd 2/4/2008 21:14'!
questionGlyphInfoInto: glyphInfoArray

	| f ascii |
	f := fontArray at: 1.
	ascii := $? asciiValue.
	glyphInfoArray at: 1 put: f glyphs;
		at: 2 put: (f xTable at: ascii + 1);
		at: 3 put: (f xTable at: ascii + 2);
		at: 4 put: (self ascentOf: $?);
		at: 5 put: self.
	^ glyphInfoArray.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
reset
	"Reset the cache of derivative emphasized fonts"

	derivativeFonts := Array new: 32.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:13'!
subscript

	^ (fontArray  at: 1) subscript
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:13'!
superscript

	^ (fontArray  at: 1) superscript
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'yo 8/5/2003 15:31'!
textStyle

	^ TextStyle actualTextStyles detect: [:aStyle | (aStyle fontArray collect: [:s | s name]) includes: self name]
		ifNone: [].
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'ar 4/12/2005 17:15'!
widthOf: aCharacter 
	"Answer the width of the argument as a character in the receiver."
	^(self fontOf: aCharacter) widthOf: aCharacter! !

!StrikeFontSet methodsFor: 'measuring' stamp: 'JMM 11/4/2008 23:13'!
widthOfString: aString

	aString ifNil:[^0].
	"Optimizing"
	(aString isByteString) ifTrue: [
		^ (self fontArray  at: 1) widthOfString: aString from: 1 to: aString size].
	^ self widthOfString: aString from: 1 to: aString size.
"
	TextStyle default defaultFont widthOfString: 'zort' 21
"
! !

!StrikeFontSet methodsFor: 'measuring' stamp: 'sd 2/4/2008 21:20'!
widthOfString: aString from: startIndex to: stopIndex
	"Measure the length of the given string between start and stop index"

	| resultX |
	resultX := 0.
	startIndex to: stopIndex do:[:i | 
		resultX := resultX + (self widthOf: (aString at: i))].
	^ resultX.
! !

!StrikeFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:14'!
xTable
	"Answer an Array of the left x-coordinate of characters in glyphs."

	^ (fontArray  at: 1) xTable.
! !

!StrikeFontSet methodsFor: 'as yet unclassified' stamp: 'yo 9/17/2002 17:56'!
xTableEncoding: anInteger
	"Answer an Array of the left x-coordinate of characters in glyphs."

	^(fontArray at: anInteger + 1) xTable.
! !

AbstractFont subclass: #TTCFont
	instanceVariableNames: 'ttcDescription pointSize foregroundColor cache derivatives fallbackFont height ascent descent colorToCacheMap'
	classVariableNames: 'GlyphCacheData GlyphCacheIndex GlyphCacheReady GlyphCacheSize NamesToIndexes Registry Scale ShutdownList'
	poolDictionaries: 'TextConstants'
	category: 'Multilingual-Display'!

!TTCFont commentStamp: '<historical>' prior: 0!
I represent a font that uses TrueType derived glyph.  Upon a request for glyph for a character through a call to #formOf: (or #widthOf:), I first search corresponding glyph in the cache.  If there is not, it creates a 32bit depth form with the glyph.

  The cache is weakly held.  The entries are zapped at full GC.

Structure:
 ttcDescription	TTFontDescription -- The system data structure for a TrueType font data file.
 pointSize		Number -- Nominal Em size in points. Conversion to pixel sizes depends on the definition of TextStyle class>>pixelsPerInch.
 foregroundColor	Color -- So far, this font need to know the glyph color in cache.
 cache			WeakArray of <Color -> <Array(256) of glyph>>
 derivatives		Array -- stores the fonts in the same family but different emphasis.
!

TTCFont subclass: #LinedTTCFont
	instanceVariableNames: 'emphasis lineGlyph contourWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!LinedTTCFont class methodsFor: 'as yet unclassified' stamp: 'ar 11/14/2006 15:18'!
fromTTCFont: aTTCFont emphasis: code

	| inst |
	inst := self new.
	inst ttcDescription: aTTCFont ttcDescription.
	inst pointSize: aTTCFont pointSize.
	inst emphasis: (aTTCFont emphasis bitOr: code).
	inst lineGlyph: (aTTCFont ttcDescription at: $_).

	^ inst.
! !

!LinedTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:11'!
computeForm: char

	| ttGlyph scale |

	char = Character tab ifTrue: [^ super computeForm: char].

	"char = $U ifTrue: [self doOnlyOnce: [self halt]]."
	scale := self pixelSize asFloat / (ttcDescription ascender - ttcDescription descender).
	ttGlyph := ttcDescription at: char.
	^ ttGlyph asFormWithScale: scale ascender: ttcDescription ascender descender: ttcDescription descender fgColor: foregroundColor bgColor: Color transparent depth: self depth replaceColor: false lineGlyph: lineGlyph lingGlyphWidth: contourWidth emphasis: emphasis! !

!LinedTTCFont methodsFor: 'as yet unclassified' stamp: 'yo 5/6/2004 19:56'!
emphasis

	^ emphasis.
! !

!LinedTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:11'!
emphasis: code

	emphasis := code.
! !

!LinedTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:11'!
lineGlyph: aGlyph

	lineGlyph := aGlyph.
	contourWidth := aGlyph calculateWidth.
! !

TTCFont subclass: #MultiTTCFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!MultiTTCFont class methodsFor: 'as yet unclassified' stamp: 'yo 12/10/2002 18:34'!
cacheAllNil
"
	self cacheAllNil
"
	self allInstances do: [:inst |
		inst cache do: [:e |
			e third ifNotNil: [^ false].
		].
	].

	^ true.
! !

!MultiTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:11'!
access: char at: index

	| wcache entry |
	wcache := self cache.
	entry := wcache at: index.
	wcache replaceFrom: index to: wcache size - 1 with: wcache startingAt: index + 1.
	wcache at: wcache size put: entry.
! !

!MultiTTCFont methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/6/2010 08:47'!
at: char put: form

	| wcache |
	wcache := self cache.
	wcache replaceFrom: 1 to: wcache size - 1 with: wcache startingAt: 2.
	wcache at: wcache size
		put: (Array with: char asciiValue with: foregroundColor with: form).
	^ form
! !

!MultiTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:12'!
formOf: char

	| newForm |
	self hasCached: char ifTrue: [:form :index |
		self access: char at: index.
		^ form.
	].

	newForm := self computeForm: char.
	self at: char put: newForm.
	^ newForm.
! !

!MultiTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:12'!
glyphInfoOf: char into: glyphInfoArray

	| newForm |
	self hasCached: char ifTrue: [:form :index |
		self access: char at: index.
		glyphInfoArray at: 1 put: form;
			at: 2 put: 0;
			at: 3 put: form width;
			at: 4 put: (self ascentOf: char);
			at: 5 put: self.
		^ glyphInfoArray.
	].

	newForm := self computeForm: char.
	self at: char put: newForm.

	glyphInfoArray at: 1 put: newForm;
		at: 2 put: 0;
		at: 3 put: newForm width;
		at: 4 put: (self ascentOf: char);
		at: 5 put: self.
	^ glyphInfoArray.
! !

!MultiTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:12'!
hasCached: char ifTrue: twoArgBlock

	| value elem |
	value := char asciiValue.

	self cache size to: 1 by: -1 do: [:i |
		elem := self cache at: i.
		(elem first = value and: [elem second = foregroundColor]) ifTrue: [
			^ twoArgBlock value: elem third value: i.
		].
	].
	^ false.
! !

!MultiTTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:12'!
widthOf: char

	"This method cannot use #formOf: because formOf: discriminates the color and causes unnecessary bitmap creation."

	| newForm |
	self hasCached: char ifTrue: [:form :index |
		self access: char at: index.
		^ form width.
	].

	newForm := self computeForm: char.
	self at: char put: newForm.
	^ newForm width.

! !

!TTCFont class methodsFor: 'objects from disk' stamp: 'nk 6/25/2003 13:42'!
classVersion
	"Version 0 had pixelSize; version 1 changed it to pointSize"
	^1! !

!TTCFont class methodsFor: 'instance creation' stamp: 'yo 6/23/2003 18:44'!
family: f size: s

	^ self allInstances detect: [:a | a familyName = f and: [a pointSize = s]] ifNone: [nil].
! !

!TTCFont class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
familyName: n pointSize: s emphasis: code

	"(TTCFont familyName: 'BitstreamVeraSans' pointSize: 12 emphasis: 0)"
	| t ret index |
	t := self registry at: n asSymbol ifAbsent: [#()].
	t isEmpty ifTrue: [
		t := (TextSharedInformation at: #DefaultTextStyle) fontArray.
		ret := t first.
		ret pointSize >= s ifTrue: [^ ret emphasis: code].
		index := 2.
		[index <= t size and: [(t at: index) pointSize <= s]] whileTrue: [
			ret := t at: index.
			index := index + 1.
		].
		^ ret emphasis: code.
	].
	^ ((TextStyle named: n) addNewFontSize: s) emphasis: code.
! !

!TTCFont class methodsFor: 'file list services' stamp: 'nk 7/16/2003 15:40'!
fileReaderServicesForFile: fullName suffix: suffix 
	^(suffix = 'ttf')  | (suffix = '*') 
		ifTrue: [ self services ]
		ifFalse: [ #() ]! !

!TTCFont class methodsFor: 'instance creation' stamp: 'sd 2/4/2008 21:20'!
getExistings: fontArray

	| result em |
	result := OrderedCollection new.
	result add: fontArray.
	1 to: 3 do: [:i |
		em := (fontArray collect: [:f | f emphasized: i]).
		(em at: 1) ~= (fontArray at: 1) ifTrue: [
			result add: em.
		].
	].
	^ result asArray.
! !

!TTCFont class methodsFor: 'initialization' stamp: 'ar 11/14/2006 15:48'!
initialize
"
	self initialize
"

	| tt |
	self allSubInstancesDo:[:fnt| fnt flushCache].
	GlyphCacheSize := 512.
	GlyphCacheData := Array new: GlyphCacheSize.
	GlyphCacheIndex := 0.
	GlyphCacheReady := true.
	
	tt := TTFontDescription default.
	tt ifNotNil: [self newTextStyleFromTT: tt].

	(FileList respondsTo: #registerFileReader:) ifTrue: [
		FileList registerFileReader: self
	].

	Smalltalk addToShutDownList: self.! !

!TTCFont class methodsFor: 'other' stamp: 'yo 6/23/2003 19:46'!
isCacheAllNil
"
	self cacheAllNil
"
	self allInstances do: [:inst |
		inst cache do: [:e |
			e ifNotNil: [^ false].
		].
	].

	^ true.
! !

!TTCFont class methodsFor: 'instance creation' stamp: 'nice 1/5/2010 15:59'!
newTextStyleFromTT: description 
	"Create a new TextStyle from specified TTFontDescription instance."

	| array |
	array := self pointSizes collect: 
					[:pt | | f | 
					f := self new.
					f ttcDescription: description.
					f pointSize: pt].
	^self reorganizeForNewFontArray: array name: array first name asSymbol! !

!TTCFont class methodsFor: 'instance creation' stamp: 'sd 2/4/2008 21:20'!
newTextStyleFromTTFile: fileName
	"Create a new TextStyle from specified file name.  On certain versions of Windows, you can evaluate following to get Arial font into the image.  On other platforms, wait and see someone implements the support code for FontPlugin then we can start relying on the generic font lookup mechanism.
	TTCFontReader encodingTag: 0.
	self newTextStyleFromTTFile: 'C:\WINDOWS\Fonts\symbol.TTF'.
	"

	| description |
	description := TTFontDescription addFromTTFile: fileName.
	^ self newTextStyleFromTT: description.
! !

!TTCFont class methodsFor: 'instance creation' stamp: 'sd 2/4/2008 21:20'!
newTextStyleFromTTStream: readStream
"
"

	| description |
	description := TTFontDescription addFromTTStream: readStream.
	^ self newTextStyleFromTT: description.
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 6/23/2003 20:18'!
pointSizes

	"The default sizes that are created when a TextStyle is created.  You can add new sizes by the new-size feature."
	^ #(9 12 15 24 36).
! !

!TTCFont class methodsFor: 'other' stamp: 'ar 11/14/2006 15:19'!
recreateCache
"
	self recreateCache.
"
	self allSubInstances do: [:inst | inst flushCache].
	Smalltalk garbageCollect.
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 10:52'!
register: anObject at: symbolName

	self registry at: symbolName put: anObject.
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 11:11'!
registerAll
"
	TTCFont registerAll
"

	TextStyle allInstancesDo: [:e |
		(e fontArray first isMemberOf: TTCFont) ifTrue: [
			self register: e fontArray at: e fontArray first familyName asSymbol.
		].
	].
! !

!TTCFont class methodsFor: 'other' stamp: 'NorbertHartl 6/13/2008 11:45'!
registry

	^ Registry isNil
		ifTrue: [Registry := IdentityDictionary new]
		ifFalse: [Registry].
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 5/7/2004 08:09'!
removeAllDerivatives
"
	self removeAllDerivatives
"

	self allInstances do: [:s |
		s textStyle ifNotNil: [
			s textStyle fontArray do: [:f |
				f derivativeFont: nil at: 0.
			].
		].
	].
! !

!TTCFont class methodsFor: 'other' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
removeStyleName: aString

	TextSharedInformation removeKey: aString asSymbol ifAbsent: [].
	TTFontDescription removeDescriptionNamed: aString asString.
! !

!TTCFont class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
reorganizeForNewFontArray: array name: styleName

	| style existings regular altName |
	(TextSharedInformation includesKey: styleName) ifFalse: [
		TextSharedInformation at: styleName put: (TextStyle fontArray: array).
		^ TextSharedInformation at: styleName.
	].
 
	"There is a text style with the name I want to use.  See if it is a TTC font..."
	style := TextSharedInformation at: styleName.
	style isTTCStyle ifFalse: [
		altName := ((array at: 1) name, 'TT') asSymbol.
		^ self reorganizeForNewFontArray: array name: altName.
	].

	existings := (self getExistings: style fontArray), (Array with: array).
	regular := existings detect: [:e | (e at: 1) isRegular] ifNone: [existings at: 1].

	regular do: [:r |
		r addLined: r.
	].

	"The existing array may be different in size than the new one."
	existings do: [:e |
		(e at: 1) isRegular ifFalse: [
			regular do: [ :r | | f |
				f := e detect: [ :ea | ea pointSize = r pointSize ] ifNone: [ ].
				f ifNotNil: [ r derivativeFont: f ].
			].
		].
	].

	style newFontArray: regular.
	self register: regular at: styleName.
	self recreateCache.	
	^ style.
! !

!TTCFont class methodsFor: 'other' stamp: 'nice 1/5/2010 15:59'!
repairBadSizes
	"There was a bug that would cause the TTCFonts to generate incorrectly sized glyphs.
	By looking at the dimensions of cached forms,
	we can tell whether the incorrect height logic was used.
	If it was, change the point size of the font and its derivatives.
	
	Note that this is probably pointless to call after the new code has been loaded; it's here for documentation (it should be called from the CS preamble instead)."

	"TTCFont repairBadSizes"
	| repaired |
	repaired := OrderedCollection new.
	TTCFont allInstancesDo: [ :font | | computedScale cached newPointSize description desiredScale |
		cached := (font cache copyFrom: $A asciiValue + 1 to: $z asciiValue + 1)
			detect: [ :f | f notNil ] ifNone: [].
		cached := cached ifNil: [  font formOf: $A ] ifNotNil: [ cached value ].
		description := font ttcDescription.
		desiredScale := cached height asFloat / (description ascender - description descender).
		computedScale := font pixelSize asFloat / font ttcDescription unitsPerEm.
		(((computedScale / desiredScale) - 1.0 * cached height) abs < 1.0) ifFalse: [
			newPointSize := (font pointSize * desiredScale / computedScale) rounded.
			font pointSize: newPointSize; flushCache.
			repaired add: font.
			font derivativeFonts do: [ :df | df ifNotNil: [
				df pointSize: newPointSize; flushCache.
				repaired add: df. ]].
		].
	].
	repaired isEmpty ifFalse: [ repaired asArray inspect ].
! !

!TTCFont class methodsFor: 'other' stamp: 'sd 2/4/2008 21:20'!
scale: anObject

	Scale := anObject.
! !

!TTCFont class methodsFor: 'file list services' stamp: 'tbn 8/11/2010 10:21'!
serviceInstallTrueTypeFontStyle
	"Return a service to install a true type font as a text style"

	^ SimpleServiceEntry
		provider: self
		label: 'Install ttf style'
		selector: #newTextStyleFromTTFile: 
		description: 'Install a true type font as a text style'
		buttonLabel: 'Install TTF'! !

!TTCFont class methodsFor: 'file list services' stamp: ''!
services
	"Return a set of services for use in FileList"

	^ Array with: self serviceInstallTrueTypeFontStyle! !

!TTCFont class methodsFor: 'initialization' stamp: 'ar 11/14/2006 15:28'!
shutDown
	"Flush the glyph cache"
	GlyphCacheData atAllPut: nil.
	GlyphCacheIndex := 0.
	ShutdownList ifNotNil:[ShutdownList do:[:fnt| fnt flushCache]].
	ShutdownList := WeakSet new.
! !

!TTCFont class methodsFor: 'initialization' stamp: 'nk 6/25/2003 13:14'!
unload

	(FileList respondsTo: #unregisterFileReader:) ifTrue: [
		FileList unregisterFileReader: self
	]! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 10:53'!
unregister: symbolName

	self registry removeKey: symbolName ifAbsent: [].
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 6/23/2003 19:50'!
version

	^ '6.0'.
! !

!TTCFont methodsFor: 'private' stamp: 'yo 5/7/2004 12:30'!
addLined

	self addLined: self.
	self derivativeFonts do: [:e |
		e ifNotNil: [self addLined: e].
	].
! !

!TTCFont methodsFor: 'private' stamp: 'sd 2/4/2008 21:20'!
addLined: aTTCFont

	| l |
	l := LinedTTCFont fromTTCFont: aTTCFont emphasis: 4.
	self derivativeFont: l at: l emphasis.

	l := LinedTTCFont fromTTCFont: aTTCFont emphasis: 16.
	self derivativeFont: l at: l emphasis.

	l := LinedTTCFont fromTTCFont: aTTCFont emphasis: 20.
	self derivativeFont: l at: l emphasis.
! !

!TTCFont methodsFor: 'accessing' stamp: 'ar 11/14/2006 15:35'!
ascent
	ascent ifNil:[ascent := ttcDescription ascender * self pixelSize // (ttcDescription ascender - ttcDescription descender) * Scale y].
	^ (fallbackFont notNil
			and: [fallbackFont ascent > ascent])
		ifTrue: [fallbackFont ascent]
		ifFalse: [ascent]! !

!TTCFont methodsFor: 'private' stamp: 'StephaneDucasse 5/6/2010 08:50'!
at: char put: form
	| assoc |
	assoc := foregroundColor -> form.
	GlyphCacheData at: (GlyphCacheIndex := GlyphCacheIndex \\ GlyphCacheSize + 1) put: assoc.
	cache at: (char asInteger + 1) put: assoc.
	^ form! !

!TTCFont methodsFor: 'friend' stamp: 'ar 11/14/2006 15:19'!
cache
	^cache! !

!TTCFont methodsFor: 'character shapes' stamp: 'nk 11/3/2004 10:02'!
characterFormAt: character 
	"Answer a Form copied out of the glyphs for the argument,  
	character. Use a cached copy if possible."

	^self formOf: character! !

!TTCFont methodsFor: 'private' stamp: 'sd 2/4/2008 21:20'!
computeForm: char

	| ttGlyph scale |
	scale := self pixelSize asFloat / (ttcDescription ascender - ttcDescription descender).
	Scale ifNotNil: [scale := Scale * scale].
	ttGlyph := ttcDescription at: (char isCharacter ifTrue: [char charCode] ifFalse: [char]).
	^ ttGlyph asFormWithScale: scale ascender: ttcDescription ascender descender: ttcDescription descender fgColor: foregroundColor bgColor: Color transparent depth: self depth.
! !

!TTCFont methodsFor: 'copying' stamp: 'yo 12/10/2002 16:35'!
copy

	^ self.
! !

!TTCFont methodsFor: 'copying' stamp: 'yo 12/10/2002 16:35'!
deepCopy

	^ self.
! !

!TTCFont methodsFor: 'public' stamp: 'yo 12/10/2002 16:35'!
depth

	^ 32.
! !

!TTCFont methodsFor: 'friend' stamp: 'sd 2/4/2008 21:20'!
derivativeFont: aTTCFont

	| index |
	index := self indexOfSubfamilyName: (aTTCFont subfamilyName).
	index < 1 ifTrue: [
		^ self "inform: 'unknown sub family name.  This font will be skipped'".
	].

	self derivativeFont: aTTCFont at: index.

	self addLined: aTTCFont.
! !

!TTCFont methodsFor: 'friend' stamp: 'sd 2/4/2008 21:20'!
derivativeFont: aTTCFont at: index

	| newDeriv |
	aTTCFont ifNil: [derivatives := nil. ^ self].
	derivatives ifNil: [derivatives := Array new: 32].
	derivatives size < 32 ifTrue: [
		newDeriv := Array new: 32.
		newDeriv replaceFrom: 1 to: derivatives size with: derivatives.
		derivatives := newDeriv.
	].
	derivatives at: index put: aTTCFont.
! !

!TTCFont methodsFor: 'friend' stamp: 'yo 5/6/2004 19:54'!
derivativeFontArray

	^ derivatives.
! !

!TTCFont methodsFor: 'friend' stamp: 'nk 9/1/2004 13:01'!
derivativeFonts

	derivatives ifNil: [^ #()].
	^derivatives copyWithout: nil! !

!TTCFont methodsFor: 'accessing' stamp: 'ar 11/14/2006 15:43'!
descent
	"One is added to make sure the gap between lines is filled.  If we don't add, multi line selection in a text pane look ugly."
	^descent ifNil:[descent := (ttcDescription descender * self pixelSize // (ttcDescription descender - ttcDescription ascender)) * Scale y + 1].
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 11/30/2002 22:39'!
descentKern

	^ 0.
! !

!TTCFont methodsFor: 'friend' stamp: 'yo 1/7/2005 12:04'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta 

	^ self displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: aPoint y + self ascent.
! !

!TTCFont methodsFor: 'friend' stamp: 'ar 11/14/2006 15:40'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY

	| form glyphInfo destX destY hereX nextX actualFont |
	destX := aPoint x.
	glyphInfo := Array new: 5.
	startIndex to: stopIndex do: [:charIndex |
		self glyphInfoOf: (aString at: charIndex) into: glyphInfo.
		form := glyphInfo at: 1.
		hereX := glyphInfo at: 2.
		nextX := glyphInfo at: 3.
		(actualFont := glyphInfo at: 5) ==  aBitBlt lastFont
			ifFalse: [actualFont installOn: aBitBlt].
		destY := baselineY - (glyphInfo at: 4). 
		aBitBlt sourceForm: form.
		aBitBlt destX: destX.
		aBitBlt destY: destY.
		aBitBlt sourceX: hereX; sourceY: 0.
		aBitBlt width: nextX - hereX.
		aBitBlt height: form height.
		aBitBlt copyBits.
		destX := destX + (nextX - hereX) + kernDelta.
	].
	^ destX @ destY
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 5/6/2004 19:25'!
emphasis
	"Answer the emphasis code (0 to 3) corresponding to my subfamily name"
	^self indexOfSubfamilyName: self subfamilyName

! !

!TTCFont methodsFor: 'accessing' stamp: 'nk 5/26/2003 20:13'!
emphasis: code

	code > 3 ifTrue: [^ self].
	code = 0 ifTrue: [^ self].
	derivatives isNil ifTrue: [^ self].
	^ (derivatives at: code) ifNil: [self].
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 8/1/2005 12:14'!
emphasized: code

	code = 0 ifTrue: [^ self].
	derivatives ifNil: [^ self].
	(((code bitAnd: 20) ~= 0) and: [
		derivatives size < code or: [(derivatives at: code) isNil]]) ifTrue: [
		self addLined.
	].
	^ (derivatives at: code) ifNil: [self].
! !

!TTCFont methodsFor: 'accessing' stamp: 'sd 2/4/2008 21:20'!
fallbackFont
	^ fallbackFont
		ifNil: [fallbackFont := FixedFaceFont new errorFont fontSize: self height]! !

!TTCFont methodsFor: 'accessing' stamp: 'sd 2/4/2008 21:20'!
fallbackFont: aFontSetOrNil

	fallbackFont := aFontSetOrNil.
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 12/10/2002 17:08'!
familyName

	^ ttcDescription name.
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 11/30/2002 22:39'!
familySizeFace

	^ Array
		with: self familyName
		with: self height
		with: 0.
! !

!TTCFont methodsFor: 'initialize' stamp: 'ar 11/14/2006 15:17'!
flushCache
	"Flush the cache of this font"
	cache := foregroundColor := colorToCacheMap := nil.! !

!TTCFont methodsFor: 'accessing' stamp: 'dgd 8/17/2004 22:10'!
fontNameWithPointSize
	^ self name withoutTrailingDigits , ' ' , self pointSize printString! !

!TTCFont methodsFor: 'public' stamp: 'yo 11/16/2002 00:59'!
foregroundColor

	^ foregroundColor.
! !

!TTCFont methodsFor: 'initialize' stamp: 'ar 11/14/2006 15:27'!
foregroundColor: fgColor
	"Install the given foreground color"
	foregroundColor = fgColor ifFalse:[
		foregroundColor := fgColor.
		colorToCacheMap ifNil:[colorToCacheMap := Dictionary new].
		cache := colorToCacheMap at: fgColor ifAbsentPut:[WeakArray new: 256].
		ShutdownList ifNotNil:[ShutdownList add: self].
	].
! !

!TTCFont methodsFor: 'private' stamp: 'ar 11/14/2006 16:03'!
formOf: char

	| code form |
	char charCode > 255
		ifTrue: [^ self fallbackFont formOf: char].

	cache ifNil:[self foregroundColor: Color black]. "make sure we have a cache"

	code := char charCode.
	form := cache at: (code + 1).
	form class == Association ifTrue:[^self computeForm: code]. "in midst of loading"
	form ifNil:[
		form := self computeForm: code.
		cache at: code+1 put: form.
		GlyphCacheData at: (GlyphCacheIndex := GlyphCacheIndex \\ GlyphCacheSize + 1) put: form.
	].
	^form
! !

!TTCFont methodsFor: 'private' stamp: 'ar 11/14/2006 15:43'!
glyphInfoOf: aCharacter into: glyphInfoArray
	"Answer the width of the argument as a character in the receiver."

	| form |
	(self hasGlyphOf: aCharacter) ifFalse: [
		^ self fallbackFont glyphInfoOf: aCharacter into: glyphInfoArray.
	].
	form := self formOf: aCharacter.
	glyphInfoArray at: 1 put: form;
		at: 2 put: 0;
		at: 3 put: form width;
		at: 4 put: ascent "(self ascentOf: aCharacter)";
		at: 5 put: self.
	^ glyphInfoArray.
! !

!TTCFont methodsFor: 'private' stamp: 'yo 1/6/2005 04:43'!
hasGlyphOf: aCharacter

	^ aCharacter charCode <= 255
! !

!TTCFont methodsFor: 'accessing' stamp: 'ar 11/14/2006 15:44'!
height
	"Answer my height in pixels. This will answer a Float."
	^height ifNil:[height := self pixelSize * Scale y]! !

!TTCFont methodsFor: 'private' stamp: 'nk 3/25/2004 17:01'!
indexOfSubfamilyName: aName
	| decoded |

	"decodeStyleName will consume all the modifiers and leave nothing if everything was recognized."
	decoded := TextStyle decodeStyleName: aName.
	decoded second isEmpty ifTrue: [ ^decoded first ].

	"If you get a halt here - please add the missing synonym to the lookup table in TextStyle>>decodeStyleName: ."
	
	self error: 'please add the missing synonym ', aName, ' to the lookup table in TextStyle>>decodeStyleName:'.

	^0.! !

!TTCFont methodsFor: 'friend' stamp: 'alain.plantec 5/28/2009 11:09'!
initialize

	super initialize.
	foregroundColor := Color black.
! !

!TTCFont methodsFor: 'friend' stamp: 'yo 1/6/2005 21:59'!
installOn: aDisplayContext

	^aDisplayContext installTTCFont: self.
! !

!TTCFont methodsFor: 'friend' stamp: 'ar 11/14/2006 15:26'!
installOn: aDisplayContext foregroundColor: fgColor backgroundColor: bgColor
	self foregroundColor: fgColor. "install color"
	aDisplayContext installTTCFont: self foregroundColor: foregroundColor backgroundColor: bgColor
! !

!TTCFont methodsFor: 'testing' stamp: 'yo 5/6/2004 19:25'!
isRegular
	"Answer true if I am a Regular/Roman font (i.e. not bold, etc.)"
	^ (self indexOfSubfamilyName: (self subfamilyName)) = 0.
! !

!TTCFont methodsFor: 'testing' stamp: 'nk 6/25/2003 12:55'!
isTTCFont
	^true! !

!TTCFont methodsFor: 'accessing' stamp: 'dgd 12/11/2003 12:47'!
lineGrid
	"Answer the relative space between lines"
	^ self ascent + self descent! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 11/16/2002 01:00'!
maxAscii

	^ ttcDescription size.
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 11/16/2002 01:00'!
minAscii

	^ 0.
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 11/16/2002 01:00'!
name

	^ ttcDescription name.
! !

!TTCFont methodsFor: 'accessing' stamp: 'nk 4/2/2004 11:27'!
pixelSize
	"Make sure that we don't return a Fraction"
	^ TextStyle pointsToPixels: pointSize! !

!TTCFont methodsFor: 'accessing' stamp: 'nk 4/2/2004 11:27'!
pixelSize: aNumber
	"Make sure that we don't return a Fraction"
	self pointSize: (TextStyle pixelsToPoints: aNumber) rounded.
! !

!TTCFont methodsFor: 'accessing' stamp: 'yo 6/23/2003 18:39'!
pointSize

	^ pointSize.
! !

!TTCFont methodsFor: 'accessing' stamp: 'nk 7/18/2004 15:32'!
pointSize: aNumber

	self privatePointSize: aNumber.
	derivatives ifNotNil: [ derivatives do: [ :f | f ifNotNil: [ f privatePointSize: aNumber ]]].
! !

!TTCFont methodsFor: 'printing' stamp: 'yo 5/6/2004 19:25'!
printOn: aStream
	aStream nextPutAll: 'TTCFont(';
		nextPutAll: self familyName; space;
		print: self pointSize; space;
		nextPutAll: self subfamilyName;
		nextPut: $)! !

!TTCFont methodsFor: 'accessing' stamp: 'nk 7/18/2004 15:31'!
privatePointSize: aNumber 
	pointSize = aNumber
		ifFalse: [pointSize := aNumber.
			self flushCache]! !

!TTCFont methodsFor: 'caching' stamp: 'nk 3/15/2004 18:52'!
releaseCachedState
	self flushCache.! !

!TTCFont methodsFor: 'caching' stamp: 'yo 6/30/2004 14:49'!
reset
! !

!TTCFont methodsFor: 'private' stamp: 'nk 4/1/2004 09:15'!
scale

	^ self pixelSize / ttcDescription unitsPerEm
! !

!TTCFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
setupDefaultFallbackFont

	| fonts f |
	fonts := TextStyle default fontArray.
	f := fonts first.
	1 to: fonts size do: [:i |
		self height > (fonts at: i) height ifTrue: [f := fonts at: i].
	].
	self fallbackFont: f.
	self reset.

! !

!TTCFont methodsFor: 'friend' stamp: 'sd 2/4/2008 21:20'!
setupDefaultFallbackFontTo: aTextStyleOrNil
"
	TTCFont allInstances do: [:i | i setupDefaultFallbackFontTo: (TextStyle named: 'MultiMSMincho')].
"

	| fonts f |
	aTextStyleOrNil ifNil: [
		self fallbackFont: nil.
		^ self.
	].
	fonts := aTextStyleOrNil fontArray.
	(aTextStyleOrNil defaultFont familyName endsWith: self familyName) ifTrue: [fallbackFont := nil. ^ self].

	f := fonts first.
	1 to: fonts size do: [:i |
		self height >= (fonts at: i) height ifTrue: [f := fonts at: i].
	].
	self fallbackFont: f.
	self reset.

! !

!TTCFont methodsFor: 'public' stamp: 'yo 12/10/2002 16:36'!
size

	^ ttcDescription size.
! !

!TTCFont methodsFor: 'private' stamp: 'yo 5/6/2004 19:23'!
subfamilyName

	^ ttcDescription subfamilyName.
! !

!TTCFont methodsFor: 'accessing' stamp: 'nk 6/17/2003 14:26'!
textStyle
	^ TextStyle actualTextStyles detect:
		[:aStyle | aStyle fontArray includes: self] ifNone: [nil]! !

!TTCFont methodsFor: 'friend' stamp: 'yo 11/16/2002 01:01'!
ttcDescription

	^ ttcDescription.
! !

!TTCFont methodsFor: 'friend' stamp: 'ar 11/14/2006 15:19'!
ttcDescription: aTTCDescription

	ttcDescription := aTTCDescription.
	self flushCache.
! !

!TTCFont methodsFor: 'copying' stamp: 'yo 12/10/2002 16:36'!
veryDeepCopyWith: deepCopier

	self flushCache.
	^ self.
! !

!TTCFont methodsFor: 'public' stamp: 'ar 11/14/2006 15:23'!
widthOf: aCharacter
	"This method cannot use #formOf: because formOf: discriminates the color and causes unnecessary bitmap creation."
	aCharacter charCode > 255 ifTrue: [
		fallbackFont ifNotNil: [^ fallbackFont widthOf: aCharacter].
		^ 1
	].
	^(self formOf: aCharacter) width! !

TTFontDescription subclass: #TTCFontDescription
	instanceVariableNames: ''
	classVariableNames: 'TTCDefault TTCDescriptions'
	poolDictionaries: 'TextConstants'
	category: 'Multilingual-Display'!

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
addFromTTFile: fileName
"
	Execute the following only if you know what you are doing.
	self addFromTTFile: 'C:\WINDOWS\Fonts\msgothic.TTC'
"

	| tt old |
	(fileName asLowercase endsWith: 'ttf') ifTrue: [
		tt := TTCFontReader readTTFFrom: (FileStream readOnlyFileNamed: fileName).
	] ifFalse: [
		tt := TTCFontReader readFrom: (FileStream readOnlyFileNamed: fileName).
	].
		
	old := TTCDescriptions detect: [:f | f first name = tt first name] ifNone: [nil].
	old ifNotNil: [TTCDescriptions remove: old].
	TTCDescriptions add: tt.
	^ tt.
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
clearDefault
"
	self clearDefault
"

	TTCDefault := nil.
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
clearDescriptions
"
	self clearDescriptions
"

	TTCDescriptions := Set new.
	TTCDefault ifNotNil: [TTCDescriptions add: TTCDefault].
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'yo 11/30/2002 22:44'!
default

	^ TTCDefault.
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'yo 12/10/2002 19:29'!
descriptionNamed: descriptionName

	^ TTCDescriptions detect: [:f | f first name = descriptionName] ifNone: [TTCDefault].
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
descriptionNamed: descriptionName at: index

	| array |
	(array :=  self descriptionNamed: descriptionName) ifNil: [^ nil].
	^ array at: index.
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'yo 11/30/2002 23:10'!
initialize
"
	self initialize
"

	self clearDescriptions.
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
removeDescriptionNamed: descriptionName

	| tt |
	TTCDescriptions ifNil: [^ self].
	[(tt := TTCDescriptions detect: [:f | ('Multi', f first name) = descriptionName] ifNone: [nil]) notNil] whileTrue:[
		 TTCDescriptions remove: tt
	].
! !

!TTCFontDescription class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
setDefault
"
	self setDefault
"

	TTCDefault := TTCFontReader readFrom: (FileStream readOnlyFileNamed: 'C:\WINDOWS\Fonts\msgothic.ttc').
	self clearDescriptions.

! !

!TTCFontDescription methodsFor: 'accessing' stamp: 'sd 2/4/2008 21:20'!
at: aCharOrInteger

	| char |
	char := aCharOrInteger asCharacter.
	^ glyphs at: (char charCode) + 1.
! !

AbstractFont subclass: #TTCFontSet
	instanceVariableNames: 'name fontArray foregroundColor'
	classVariableNames: 'Registry'
	poolDictionaries: 'TextConstants'
	category: 'Multilingual-Display'!

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
discardDefault
"
	self discardDefault
"
	| ttc |
	ttc := TTCFontDescription default.
	ttc ifNotNil: [
		TextSharedInformation removeKey: ttc name asSymbol ifAbsent: [].
	].! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
familyName: n pointSize: s

	"(self familyName: 'MultiMSGothic' pointSize: 14) pointSize"
	| t ret index |
	t := self registry at: n asSymbol ifAbsent: [#()].
	t isEmpty ifTrue: [
		t := (TextSharedInformation at: #DefaultTextStyle) fontArray.
		ret := t first.
		ret pointSize >= s ifTrue: [^ ret].
		index := 2.
		[index <= t size and: [(t at: index) pointSize <= s]] whileTrue: [
			ret := t at: index.
			index := index + 1.
		].
		^ ret.
	].
	^ (TextStyle named: n) addNewFontSize: s.! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
initialize
"
	self initialize
"

	| tt |
	tt := TTCFontDescription default.
	tt ifNotNil: [self newTextStyleFromTT: tt].
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 11/16/2002 01:18'!
newFontArray: anArray
 
	^super new initializeWithFontArray: anArray
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
newTextStyleFromTT: descriptionArray

	| array textStyle styleName arrayOfArray |

	arrayOfArray := self pointSizes collect: [:pt |
		descriptionArray collect: [:ttc | | f |
			ttc ifNil: [nil] ifNotNil: [
				f := (ttc size > 256)
					ifTrue: [MultiTTCFont new initialize]
					ifFalse: [TTCFont new initialize].
				f ttcDescription: ttc.
				f pointSize: pt.
			].
		].
	].

	array := arrayOfArray collect: [:fonts |
		self newFontArray: fonts.
	].

	styleName := (array at: 1) familyName asSymbol.
	textStyle := TextStyle fontArray: array.
	TextSharedInformation at: styleName put: textStyle.

	self register: array at: styleName.

	^ TextSharedInformation at: styleName.
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
newTextStyleFromTTFile: fileName
"
	TTCFontReader encodingTag: JapaneseEnvironment leadingChar.
	self newTextStyleFromTTFile: 'C:\WINDOWS\Fonts\msmincho.TTC'

	TTCFontReader encodingTag: 0.
	self newTextStyleFromTTFile: 'C:\WINDOWS\Fonts\symbol.ttf'
"

	| description |
	description := TTCFontDescription addFromTTFile: fileName.
	^ self newTextStyleFromTT: description.
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 11/30/2002 22:21'!
pointSizes

	^ TTCFont pointSizes.
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 12/2/2004 12:50'!
register: anObject at: symbolName

	self registry at: symbolName put: anObject.
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 12/2/2004 13:07'!
registry

	^ Registry isNil
		ifTrue: [Registry := IdentityDictionary new]
		ifFalse: [Registry].
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
removeStyleName: aString

	| style symName |
	symName := aString asSymbol.
	style := TextSharedInformation removeKey: symName ifAbsent: [].
	style ifNotNil: [self unregister: symName].
	TTCFontDescription removeDescriptionNamed: aString asString.
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
setDefault
"
	self setDefault
"
	| tt |
	tt := TTCFontDescription default.
	tt ifNil: [TTCFontDescription setDefault].
	tt := TTCFontDescription default.
	tt ifNotNil: [self newTextStyleFromTT: tt].
! !

!TTCFontSet class methodsFor: 'as yet unclassified' stamp: 'yo 12/2/2004 12:49'!
unregister: symbolName

	self registry removeKey: symbolName ifAbsent: [].
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'yo 11/16/2002 01:15'!
ascent

	^ (fontArray at: 1) ascent.
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 22:57'!
ascentOf: aCharacter

	^ (fontArray at: 1) ascentOf: aCharacter.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'yo 12/10/2002 18:28'!
depth

	^ (fontArray at: 1) depth.
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'yo 11/16/2002 01:16'!
descent

	^ (fontArray at: 1) descent.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'yo 11/16/2002 01:16'!
descentKern

	^ 0.
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:29'!
descentOf: aChar

	^ (fontArray  at: 1) descentOf: aChar
! !

!TTCFontSet methodsFor: 'displaying' stamp: 'yo 1/7/2005 12:05'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta

	^ self displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: aPoint y + self ascent.
! !

!TTCFontSet methodsFor: 'displaying' stamp: 'nice 3/16/2010 20:13'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY

	| destPoint font form encoding glyphInfo char charCode destY |
	destPoint := aPoint.
	glyphInfo := Array new: 5.
	startIndex to: stopIndex do: [:charIndex |
		char := aString at: charIndex.
		encoding := char leadingChar + 1.
		charCode := char charCode.
		font := fontArray at: encoding.
		((charCode between: font minAscii and: font maxAscii) not) ifTrue: [
			charCode := font maxAscii].
		self glyphInfoOf: char into: glyphInfo.
		form := glyphInfo at: 1.
		(glyphInfo fifth ~= aBitBlt lastFont) ifTrue: [
			glyphInfo fifth installOn: aBitBlt.
		].
		destY := baselineY - glyphInfo fourth. 
		aBitBlt
			sourceForm: form;
			destX: destPoint x;
			destY: destY;
			sourceOrigin: 0 @ 0;
			width: form width;
			height: form height;
			copyBits.
		destPoint := destPoint x + (form width + kernDelta) @ destPoint y.
	].
	^ destPoint.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'nice 3/16/2010 20:14'!
displayStringR2L: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta 

	| destPoint font form encoding char charCode glyphInfo |
	destPoint := aPoint.
	glyphInfo := Array new: 5.
	startIndex to: stopIndex do: [:charIndex |
		char := aString at: charIndex.
		encoding := char leadingChar + 1.
		charCode := char charCode.
		font := fontArray at: encoding.
		((charCode between: font minAscii and: font maxAscii) not) ifTrue: [
			charCode := font maxAscii].
		self glyphInfoOf: char into: glyphInfo.
		form := glyphInfo at: 1.
			(glyphInfo size > 4 and: [(glyphInfo at: 5) notNil and: [(glyphInfo at: 5) ~= aBitBlt lastFont]]) ifTrue: [
				(glyphInfo at: 5) installOn: aBitBlt.
			].
		aBitBlt
			sourceForm: form;
			destX: destPoint x - form width;
			destY: destPoint y;
			sourceOrigin: 0 @ 0;
			width: form width;
			height: form height;
			copyBits.
		destPoint := destPoint x - (form width + kernDelta) @ destPoint y.
	].
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:29'!
emphasis
	^ (fontArray  at: 1) emphasis! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'yo 11/16/2002 01:16'!
emphasized: code

! !

!TTCFontSet methodsFor: 'accessing' stamp: 'yo 12/10/2002 18:20'!
familyName

	^ 'Multi', (fontArray at: 1) familyName.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:29'!
familySizeFace

	^ Array
		with: (fontArray  at: 1) name
		with: self height
		with: 0.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'yo 11/16/2002 01:16'!
fontArray

	^ fontArray
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
glyphInfoOf: aCharacter into: glyphInfoArray

	| index f code |
	index := aCharacter leadingChar + 1.
	fontArray size < index ifTrue: [^ self questionGlyphInfoInto: glyphInfoArray].
	(f := fontArray at: index) ifNil: [^ self questionGlyphInfoInto: glyphInfoArray].

	code := aCharacter charCode.
	((code between: f minAscii and: f maxAscii) not) ifTrue: [
		^ self questionGlyphInfoInto: glyphInfoArray.
	].
	f glyphInfoOf: aCharacter into: glyphInfoArray.
	glyphInfoArray at: 5 put: self.
	^ glyphInfoArray.
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:29'!
height

	^(fontArray at: 1) pixelSize.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
initializeWithFontArray: anArray

	fontArray := anArray.
	"name := anArray first name."
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'yo 1/6/2005 22:00'!
installOn: aDisplayContext

	^aDisplayContext installTTCFont: self.
! !

!TTCFontSet methodsFor: 'displaying' stamp: 'sd 2/4/2008 21:20'!
installOn: aDisplayContext foregroundColor: fgColor backgroundColor: bgColor

	foregroundColor := fgColor.
	fontArray do: [:s | s ifNotNil: [s installOn: aDisplayContext foregroundColor: fgColor backgroundColor: bgColor]].
! !

!TTCFontSet methodsFor: 'testing' stamp: 'yo 2/12/2007 19:34'!
isFontSet

	^ true.
! !

!TTCFontSet methodsFor: 'testing' stamp: 'yo 12/29/2003 15:02'!
isTTCFont
	^true! !

!TTCFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:30'!
lineGrid

	^ (fontArray  at: 1) lineGrid.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
maxAsciiFor: encoding

	| f |
	f := (fontArray at: encoding+1).
	f ifNotNil: [^ f maxAscii].
	^ 0.
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'JMM 11/4/2008 23:30'!
pointSize

	^ (fontArray  at: 1) pixelSize * 72 // 96.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'yo 11/16/2002 01:27'!
pointSizes

	^ self class pointSizes.
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
questionGlyphInfoInto: glyphInfoArray

	| f form |
	f := fontArray at: 1.
	form := f formOf: $?.
	glyphInfoArray at: 1 put: form;
		at: 2 put: 0;
		at: 3 put: form width;
		at: 4 put: self.
	^ glyphInfoArray.
! !

!TTCFontSet methodsFor: 'accessing' stamp: 'yo 8/5/2003 15:31'!
textStyle

	^ TextStyle actualTextStyles
		detect: [:aStyle | (aStyle fontArray collect: [:s | s name]) includes: self name]
		ifNone: [].
! !

!TTCFontSet methodsFor: 'as yet unclassified' stamp: 'JMM 11/4/2008 23:30'!
ttcDescription
	^ (fontArray  at: 1) ttcDescription! !

!TTCFontSet methodsFor: 'measuring' stamp: 'sd 2/4/2008 21:20'!
widthOf: aCharacter

	| encoding |
	encoding := aCharacter leadingChar.
	^ (fontArray at: encoding + 1) widthOf: aCharacter.
! !

!KoreanEnvironment methodsFor: '*Multilingual-Display' stamp: 'janggoon 11/6/2008 23:57'!
fontDownloadUrls
	^ #('http://squeak.kr/data/' )! !

BDFFontReader subclass: #EFontBDFFontReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!EFontBDFFontReader methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 20:28'!
readCharactersInRangeFrom: start to: stop totalNums: upToNum storeInto: chars

	| array form code |
	1 to: upToNum do: [:i |
		array := self readOneCharacter.
		code := array at: 2.
		code > stop ifTrue: [^ self].
		(code between: start and: stop) ifTrue: [
			form := array at: 1.
			form ifNotNil: [
				chars add: array.
			].
		].
	].
! !

!EFontBDFFontReader methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
readFrom: start to: end 
	| xTable glyphs ascent descent chars charsNum height form blt lastAscii pointSize ret lastValue encoding bbx strikeWidth minAscii maxAscii maxWidth |
	form := encoding := bbx := nil.
	self initialize.
	self readAttributes.
	height := Integer readFromString: ((properties at: #FONTBOUNDINGBOX) at: 2).
	ascent := Integer readFromString: (properties at: 'FONT_ASCENT' asSymbol) first.
	descent := Integer readFromString: (properties at: 'FONT_DESCENT' asSymbol) first.
	(properties includesKey: 'POINT_SIZE' asSymbol) 
		ifTrue: 
			[ pointSize := (Integer readFromString: (properties at: 'POINT_SIZE' asSymbol) first) // 10 ]
		ifFalse: [ pointSize := (ascent + descent) * 72 // 96 ].
	maxWidth := 0.
	minAscii := 2097152.
	strikeWidth := 0.
	maxAscii := 0.
	charsNum := Integer readFromString: (properties at: #CHARS) first.
	chars := Set new: charsNum.
	self 
		readCharactersInRangeFrom: start
		to: end
		totalNums: charsNum
		storeInto: chars.
	chars := chars asSortedCollection: [ :x :y | (x at: 2) <= (y at: 2) ].
	charsNum := chars size.	"undefined encodings make this different"
	chars do: 
		[ :array | | width | 
		encoding := array at: 2.
		bbx := array at: 3.
		width := bbx at: 1.
		maxWidth := maxWidth max: width.
		minAscii := minAscii min: encoding.
		maxAscii := maxAscii max: encoding.
		strikeWidth := strikeWidth + width ].
	glyphs := Form extent: strikeWidth @ height.
	blt := BitBlt toForm: glyphs.
	"xTable := XTableForUnicodeFont new ranges: (Array with: (Array with: start with: end))."
	xTable := SparseLargeTable 
		new: end + 3
		chunkSize: 32
		arrayClass: Array
		base: start + 1
		defaultValue: -1.
	lastAscii := start.
	1 
		to: charsNum
		do: 
			[ :i | 
			form := (chars at: i) first.
			encoding := (chars at: i) second.
			bbx := (chars at: i) third.
			"lastAscii+1 to: encoding-1 do: [:a | xTable at: a+2 put: (xTable at: a+1)]."
			lastValue := xTable at: lastAscii + 1 + 1.
			xTable 
				at: encoding + 1
				put: lastValue.
			blt 
				copy: ((xTable at: encoding + 1) @ (ascent - (bbx at: 2) - (bbx at: 4)) extent: (bbx at: 1) @ (bbx at: 2))
				from: 0 @ 0
				in: form.
			xTable 
				at: encoding + 2
				put: (xTable at: encoding + 1) + (bbx at: 1).
			lastAscii := encoding ].
	xTable zapDefaultOnlyEntries.
	ret := Array new: 8.
	ret 
		at: 1
		put: xTable.
	ret 
		at: 2
		put: glyphs.
	ret 
		at: 3
		put: minAscii.
	ret 
		at: 4
		put: maxAscii.
	ret 
		at: 5
		put: maxWidth.
	ret 
		at: 6
		put: ascent.
	ret 
		at: 7
		put: descent.
	ret 
		at: 8
		put: pointSize.
	^ ret
	" ^{xTable. glyphs. minAscii. maxAscii. maxWidth. ascent. descent. pointSize}"! !

EFontBDFFontReader subclass: #EFontBDFFontReaderForRanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!EFontBDFFontReaderForRanges class methodsFor: 'as yet unclassified' stamp: 'yo 1/19/2005 11:24'!
rangesForGreek

	^ {
		Array with: 16r1 with: 16rFF.
		Array with: 16r370 with: 16r3FF.
		Array with: 16r1F00 with: 16r1FFF.
		Array with: 16r2000 with: 16r206F.
		Array with: 16r20A0 with: 16r20AF
	}.
! !

!EFontBDFFontReaderForRanges class methodsFor: 'as yet unclassified' stamp: 'yo 1/19/2005 11:24'!
rangesForLatin2

	^ {
		Array with: 0 with: 16r17F.
		Array with: 16r2B0 with: 16r2FF.
		Array with: 16r2000 with: 16r206F.
		Array with: 16r2122 with: 16r2122.
		Array with: 16rFFFF with: 16rFFFF. "sentinel"
	}.
! !

!EFontBDFFontReaderForRanges class methodsFor: 'as yet unclassified' stamp: 'yo 12/11/2007 11:19'!
rangesForRussian

	^ {
		Array with: 16r1 with: 16rFF.
		Array with: 16r400 with: 16r513.
		Array with: 16r2219 with: 16r2219.
		Array with: 16r221A with: 16r221A.
		Array with: 16r2248 with: 16r2248.
		Array with: 16r2264 with: 16r2265.
		Array with: 16r2320 with: 16r2321.
		Array with: 16r2500 with: 16r25A0.
	}.
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 20:32'!
additionalRangesForJapanese

	| basics |
	basics := {
		Array with: 16r5C with: 16rFF3C.
		Array with: 16r3013 with: 16rFFFD.
	}.
	^ basics
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 20:32'!
additionalRangesForKorean

	| basics |
	basics := {
		Array with: 16rA1 with: 16rFFE6C.
		Array with: 16r3000 with: 16rFFFD.
	}.
	^ basics
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'pmm 3/13/2010 11:22'!
override: chars with: otherFileName ranges: pairArray transcodingTable: table additionalRange: additionalRange 
	| other rangeStream newChars currentRange |
	other := BDFFontReader readOnlyFileNamed: otherFileName.
	rangeStream := pairArray readStream.
	currentRange := rangeStream next.
	newChars := PluggableSet new.
	newChars hashBlock: [ :elem | (elem at: 2) hash ].
	newChars equalBlock: [ :a :b | (a at: 2) = (b at: 2) ].
	other readChars do: 
		[ :array | | u form j code | 
		code := array at: 2.
		"code printStringHex printString displayAt: 0@0."
		code > currentRange last ifTrue: 
			[ 
			[ rangeStream atEnd not and: 
				[ currentRange := rangeStream next.
				currentRange last < code ] ] whileTrue.
			rangeStream atEnd ifTrue: 
				[ newChars addAll: chars.
				^ newChars ] ].
		(code 
			between: currentRange first
			and: currentRange last) ifTrue: 
			[ form := array at: 1.
			form ifNotNil: 
				[ j := array at: 2.
				u := table at: (j // 256 - 33) * 94 + (j \\ 256 - 33) + 1.
				u ~= -1 ifTrue: 
					[ array 
						at: 2
						put: u.
					newChars add: array.
					additionalRange do: 
						[ :e | | newArray | 
						e first = (array at: 2) ifTrue: 
							[ newArray := array shallowCopy.
							newArray 
								at: 2
								put: e second.
							newChars add: newArray ] ] ] ] ] ].
	self error: 'should not reach here'! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 20:34'!
rangesForJapanese

	| basics etc |
	basics := {
		Array with: 16r5C with: 16r5C.
		Array with: 16rA2 with: 16rA3.
		Array with: 16rA7 with: 16rA8.
		Array with: 16rAC with: 16rAC.
		Array with: 16rB0 with: 16rB1.
		Array with: 16rB4 with: 16rB4.
		Array with: 16rB6 with: 16rB6.
		Array with: 16rD7 with: 16rD7.
		Array with: 16rF7 with: 16rF7
	}.
	etc := {
		Array with: 16r370 with: 16r3FF. "greek"
		Array with: 16r400 with: 16r52F. "cyrillic"
		Array with: 16r1D00 with: 16r1D7F. "phonetic"
		Array with: 16r1E00 with: 16r1EFF. "latin extended additional"
		Array with: 16r2000 with: 16r206F. "general punctuation"
		Array with: 16r20A0 with: 16r20CF. "currency symbols"
		Array with: 16r2100 with: 16r214F. "letterlike"
		Array with: 16r2150 with: 16r218F. "number form"
		Array with: 16r2190 with: 16r21FF. "arrows"
		Array with: 16r2200 with: 16r22FF. "math operators"
		Array with: 16r2300 with: 16r23FF. "misc tech"
		Array with: 16r2460 with: 16r24FF. "enclosed alnum"
		Array with: 16r2500 with: 16r257F. "box drawing"
		Array with: 16r2580 with: 16r259F. "box elem"
		Array with: 16r25A0 with: 16r25FF. "geometric shapes"
		Array with: 16r2600 with: 16r26FF. "misc symbols"
		Array with: 16r2700 with: 16r27BF. "dingbats"
		Array with: 16r27C0 with: 16r27EF. "misc math A"
		Array with: 16r27F0 with: 16r27FF. "supplimental arrow A"
		Array with: 16r2900 with: 16r297F. "supplimental arrow B"
		Array with: 16r2980 with: 16r29FF. "misc math B"
		Array with: 16r2A00 with: 16r2AFF. "supplimental math op"
		Array with: 16r2900 with: 16r297F. "supplimental arrow B"
		Array with: 16r2E80 with: 16r2EFF. "cjk radicals suppliment"
		Array with: 16r2F00 with: 16r2FDF. "kangxi radicals"
		Array with: 16r3000 with: 16r303F. "cjk symbols"
		Array with: 16r3040 with: 16r309F. "hiragana"
		Array with: 16r30A0 with: 16r30FF. "katakana"
		Array with: 16r3190 with: 16r319F. "kanbun"
		Array with: 16r31F0 with: 16r31FF. "katakana extension"
		Array with: 16r3200 with: 16r32FF. "enclosed CJK"
		Array with: 16r3300 with: 16r33FF. "CJK compatibility"
		Array with: 16r3400 with: 16r4DBF. "CJK unified extension A"
		Array with: 16r4E00 with: 16r9FAF. "CJK ideograph"
		Array with: 16rF900 with: 16rFAFF. "CJK compatiblity ideograph"
		Array with: 16rFE30 with: 16rFE4F. "CJK compatiblity forms"
		Array with: 16rFF00 with: 16rFFEF. "half and full"
		Array with: 16rFFFF with: 16rFFFF. "sentinel"
	}.

	^ basics, etc.
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 20:34'!
rangesForKorean

	| basics etc |
	basics := {
		Array with: 16rA1 with: 16rFF
	}.
	etc := {
		Array with: 16r100 with: 16r17F. "extended latin"
		Array with: 16r370 with: 16r3FF. "greek"
		Array with: 16r400 with: 16r52F. "cyrillic"
		Array with: 16r2000 with: 16r206F. "general punctuation"
		Array with: 16r2100 with: 16r214F. "letterlike"
		Array with: 16r2150 with: 16r218F. "number form"
		Array with: 16r2190 with: 16r21FF. "arrows"
		Array with: 16r2200 with: 16r22FF. "math operators"
		Array with: 16r2300 with: 16r23FF. "misc tech"
		Array with: 16r2460 with: 16r24FF. "enclosed alnum"
		Array with: 16r2500 with: 16r257F. "box drawing"
		Array with: 16r2580 with: 16r259F. "box elem"
		Array with: 16r25A0 with: 16r25FF. "geometric shapes"
		Array with: 16r2600 with: 16r26FF. "misc symbols"
		Array with: 16r3000 with: 16r303F. "cjk symbols"
		Array with: 16r3040 with: 16r309F. "hiragana"
		Array with: 16r30A0 with: 16r30FF. "katakana"
		Array with: 16r3190 with: 16r319F. "kanbun"
		Array with: 16r31F0 with: 16r31FF. "katakana extension"
		Array with: 16r3200 with: 16r32FF. "enclosed CJK"
		Array with: 16r3300 with: 16r33FF. "CJK compatibility"
		Array with: 16r4E00 with: 16r9FAF. "CJK ideograph"
		Array with: 16rAC00 with: 16rD7AF. "Hangul Syllables"
		Array with: 16rF900 with: 16rFAFF. "CJK compatiblity ideograph"
		Array with: 16rFF00 with: 16rFFEF. "half and full"
	}.

	^ basics, etc.
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'yo 1/19/2005 11:20'!
rangesForLatin2

	^ {
		Array with: 0 with: 16r17F.
		Array with: 16r2B0 with: 16r2FF.
		Array with: 16r2000 with: 16r206F.
		Array with: 16r2122 with: 16r2122.
		Array with: 16rFFFF with: 16rFFFF. "sentinel"
	}.
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'damiencassou 5/30/2008 15:30'!
readCharactersInRanges: ranges storeInto: chars 
	| array form code rangeStream currentRange |
	rangeStream := ranges readStream.
	currentRange := rangeStream next.
	[ true ] whileTrue: 
		[ array := self readOneCharacter.
		array second ifNil: [ ^ self ].
		code := array at: 2.
		code > currentRange last ifTrue: 
			[ 
			[ rangeStream atEnd not and: 
				[ currentRange := rangeStream next.
				currentRange last < code ] ] whileTrue.
			rangeStream atEnd ifTrue: [ ^ self ] ].
		(code 
			between: currentRange first
			and: currentRange last) ifTrue: 
			[ form := array at: 1.
			form ifNotNil: [ chars add: array ] ] ]! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
readRanges: ranges

	| xTable glyphs ascent descent chars charsNum height form blt lastAscii pointSize ret lastValue start end encoding bbx strikeWidth minAscii maxAscii maxWidth |
	form := encoding := bbx := nil.
	self initialize.
	self readAttributes.
	height := Integer readFromString: ((properties at: #FONTBOUNDINGBOX) at: 2).
	ascent := Integer readFromString: (properties at: 'FONT_ASCENT' asSymbol) first.
	descent := Integer readFromString: (properties at: 'FONT_DESCENT' asSymbol) first.
	(properties includesKey: 'POINT_SIZE' asSymbol) ifTrue: [
		pointSize := (Integer readFromString: (properties at: 'POINT_SIZE' asSymbol) first) // 10.
	] ifFalse: [
		pointSize := (ascent + descent) * 72 // 96.
	].

	maxWidth := 0.
	minAscii := 16r200000.
	strikeWidth := 0.
	maxAscii := 0.

	charsNum := Integer readFromString: (properties at: #CHARS) first.
	chars := Set new: charsNum.

	self readCharactersInRanges: ranges storeInto: chars.

	chars := chars asSortedCollection: [:x :y | (x at: 2) <= (y at: 2)].
	charsNum := chars size. "undefined encodings make this different"

	chars do: [:array | | width |
		encoding := array at: 2.
		bbx := array at: 3..
		width := bbx at: 1.
		maxWidth := maxWidth max: width.
		minAscii := minAscii min: encoding.
		maxAscii := maxAscii max: encoding.
		strikeWidth := strikeWidth + width.
	].

	glyphs := Form extent: strikeWidth@height.
	blt := BitBlt toForm: glyphs.
	start := (ranges collect: [:r | r first]) min.
	end := (ranges collect: [:r | r second]) max + 3.

	xTable := SparseLargeTable new: end chunkSize: 64 arrayClass: Array base: start +1 defaultValue: -1.
	lastAscii := start.
	xTable at: lastAscii + 2 put: 0.
	1 to: charsNum do: [:i |
		form := (chars at: i) first.
		encoding := (chars at: i) second.
		bbx := (chars at: i) third.
		"lastAscii+1 to: encoding-1 do: [:a | xTable at: a+2 put: (xTable at: a+1)]."
		lastValue := xTable at: lastAscii + 1 + 1.
		xTable at: encoding + 1 put: lastValue.
		blt copy: (((xTable at: encoding+1)@(ascent - (bbx at: 2) - (bbx at: 4)))
				extent: (bbx at: 1)@(bbx at: 2))
			from: 0@0 in: form.
		xTable at: encoding+2 put: (xTable at: encoding+1)+(bbx at: 1).
		lastAscii := encoding.
	].
	xTable at: xTable size put: (xTable at: xTable size - 1).
	xTable zapDefaultOnlyEntries.
	ret := Array new: 8.
	ret at: 1 put: xTable.
	ret at: 2 put: glyphs.
	ret at: 3 put: minAscii.
	ret at: 4 put: maxAscii.
	ret at: 5 put: maxWidth.
	ret at: 6 put: ascent.
	ret at: 7 put: descent.
	ret at: 8 put: pointSize.
	^ret.
" ^{xTable. glyphs. minAscii. maxAscii. maxWidth. ascent. descent. pointSize}"
! !

!EFontBDFFontReaderForRanges methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
readRanges: ranges overrideWith: otherFileName otherRanges: otherRanges additionalOverrideRange: additionalRange

	| xTable glyphs ascent descent chars charsNum height form blt lastAscii pointSize ret lastValue start end encoding bbx strikeWidth minAscii maxAscii maxWidth |
	form := encoding := bbx := nil.
	self initialize.
	self readAttributes.
	height := Integer readFromString: ((properties at: #FONTBOUNDINGBOX) at: 2).
	ascent := Integer readFromString: (properties at: 'FONT_ASCENT' asSymbol) first.
	descent := Integer readFromString: (properties at: 'FONT_DESCENT' asSymbol) first.
	(properties includesKey: 'POINT_SIZE' asSymbol) ifTrue: [
		pointSize := (Integer readFromString: (properties at: 'POINT_SIZE' asSymbol) first) // 10.
	] ifFalse: [
		pointSize := (ascent + descent) * 72 // 96.
	].
		
	
	maxWidth := 0.
	minAscii := 16r200000.
	strikeWidth := 0.
	maxAscii := 0.

	charsNum := Integer readFromString: (properties at: #CHARS) first.
	chars := Set new: charsNum.

	self readCharactersInRanges: ranges storeInto: chars.
	chars := self override: chars with: otherFileName ranges: otherRanges transcodingTable: (UCSTable jisx0208Table) additionalRange: additionalRange.

	chars := chars asSortedCollection: [:x :y | (x at: 2) <= (y at: 2)].
	charsNum := chars size. "undefined encodings make this different"
	
	chars do: [:array | | width |
		encoding := array at: 2.
		bbx := array at: 3..
		width := bbx at: 1.
		maxWidth := maxWidth max: width.
		minAscii := minAscii min: encoding.
		maxAscii := maxAscii max: encoding.
		strikeWidth := strikeWidth + width.
	].

	glyphs := Form extent: strikeWidth@height.
	blt := BitBlt toForm: glyphs.
	start := ((ranges collect: [:r | r first]), (additionalRange collect: [:r2 | r2 first])) min.
	end := ((ranges collect: [:r | r second]), (additionalRange collect: [:r2 | r2 second])) max + 3.
	"xRange := Array with: (Array with: ((ranges collect: [:r | r first]), (additionalRange collect: [:r2 | r2 first])) min
						with: (((ranges collect: [:r | r second]), (additionalRange collect: [:r2 | r2 second])) max + 2))."
	"xTable := XTableForUnicodeFont new
		ranges: xRange."
	xTable := SparseLargeTable new: end chunkSize: 64 arrayClass: Array base: start defaultValue: -1.
	lastAscii := start.
	xTable at: lastAscii + 2 put: 0.
	1 to: charsNum do: [:i |
		form := (chars at: i) first.
		encoding := (chars at: i) second.
		bbx := (chars at: i) third.
		"lastAscii+1 to: encoding-1 do: [:a | xTable at: a+2 put: (xTable at: a+1)]."
		lastValue := xTable at: lastAscii + 1 + 1.
		xTable at: encoding + 1 put: lastValue.
		blt copy: (((xTable at: encoding+1)@(ascent - (bbx at: 2) - (bbx at: 4)))
				extent: (bbx at: 1)@(bbx at: 2))
			from: 0@0 in: form.
		xTable at: encoding+2 put: (xTable at: encoding+1)+(bbx at: 1).
		lastAscii := encoding.
	].
	xTable at: xTable size put: (xTable at: xTable size - 1).
	xTable zapDefaultOnlyEntries.
	ret := Array new: 8.
	ret at: 1 put: xTable.
	ret at: 2 put: glyphs.
	ret at: 3 put: minAscii.
	ret at: 4 put: maxAscii.
	ret at: 5 put: maxWidth.
	ret at: 6 put: ascent.
	ret at: 7 put: descent.
	ret at: 8 put: pointSize.
	^ret.
" ^{xTable. glyphs. minAscii. maxAscii. maxWidth. ascent. descent. pointSize}"
! !

Object subclass: #SparseXTable
	instanceVariableNames: 'tables xTables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!SparseXTable methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
tableFor: code

	| div t |
	div := code // 65536.
	t := xTables at: div ifAbsent: [ | table |table := Array new: 65536 withAll: 0. xTables at: div put: table. table].
	^ t.
! !

Object subclass: #StrikeFontFixer
	instanceVariableNames: 'strikeFont charForms newFont'
	classVariableNames: 'MappingTable NoFontTable'
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!StrikeFontFixer class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
initialize
"
	StrikeFontFixer initialize
"

	| d |
	self initializeNoFontTable.
	d := Array new: 256.
	0 to: 127 do: [:i | d at: i+1 put: i].
	16r80 to: 16r9F do: [:i | d at: i+1 put: nil].
	d at: 16rA0+1 put: 16r20.
	d at: 16rA1+1 put: 16rC1.
	d at: 16rA2+1 put: 16rA2.
	d at: 16rA3+1 put: 16rA3.
	d at: 16rA4+1 put: 16rA9. "CURRENCY SIGN"
	d at: 16rA5+1 put: 16rB4.
	d at: 16rA6+1 put: 16r7C. "BROKEN BAR"
	d at: 16rA7+1 put: 16rA4.
	d at: 16rA8+1 put: 16r80. "DIAERESIS"
	d at: 16rA9+1 put: 16rA9.
	d at: 16rAA+1 put: 16rBB.
	d at: 16rAB+1 put: 16rC7.
	d at: 16rAC+1 put: 16rD1. "NOT SIGN"
	d at: 16rAD+1 put: 16rD0.
	d at: 16rAE+1 put: 16rA8.
	d at: 16rAF+1 put: 16rD1. "MACRON"
	d at: 16rB0+1 put: 16rA1.
	d at: 16rB1+1 put: 16r2B. "PLUS-MINUS SIGN"
	d at: 16rB2+1 put: 16rAB. "SUPERSCRIPT TWO"
	d at: 16rB3+1 put: 16rAB. "SUPERSCRIPT THREE"
	d at: 16rB4+1 put: 16rAB.
	d at: 16rB5+1 put: 16r75. "MICRO SIGN"
	d at: 16rB6+1 put: 16rA6.
	d at: 16rB7+1 put: 16rA5.
	d at: 16rB8+1 put: 16r82. "CEDILLA"
	d at: 16rB9+1 put: 16rAB. "SUPERSCRIPT ONE"
	d at: 16rBA+1 put: 16rBC.
	d at: 16rBB+1 put: 16rC8.
	d at: 16rBC+1 put: 16r4D. "VULGAR FRACTION ONE QUARTER"
	d at: 16rBD+1 put: 16r4D. "VULGAR FRACTIOIN ONE HALF"
	d at: 16rBE+1 put: 16r4D. "VALGAR FRACTION THREE QUARTERS"
	d at: 16rBF+1 put: 16rC0.
	d at: 16rC0+1 put: 16rCB.
	d at: 16rC1+1 put: 16rCB. "CAPITAL A WITH ACUTE"
	d at: 16rC2+1 put: 16rCB. "CAPITAL A WITH CIRCUMFLEX"
	d at: 16rC3+1 put: 16rCC.
	d at: 16rC4+1 put: 16r80.
	d at: 16rC5+1 put: 16r81.
	d at: 16rC6+1 put: 16rAE.
	d at: 16rC7+1 put: 16r82.
	d at: 16rC8+1 put: 16r83. "CAPITAL E WITH GRAVE"
	d at: 16rC9+1 put: 16r83.
	d at: 16rCA+1 put: 16r83. "CAPITAL E WITH CIRCUMFLEX"
	d at: 16rCB+1 put: 16r83. "CAPITAL E WITH DIAERESIS"
	d at: 16rCC+1 put: 16r49. "CAPITAL I WITH GRAVE"
	d at: 16rCD+1 put: 16r49. "CAPITAL I WITH ACUTE"
	d at: 16rCE+1 put: 16r49. "CAPITAL I WITH CIRCUMFLEX"
	d at: 16rCF+1 put: 16r49. "CAPITAL I WITH DIAERESIS"
	d at: 16rD0+1 put: 16r44. "CAPITAL ETH"
	d at: 16rD1+1 put: 16r84.
	d at: 16rD2+1 put: 16rCD. "CAPITAL O WITH GRAVE"
	d at: 16rD3+1 put: 16rCD. "CAPITAL O WITH ACUTE"
	d at: 16rD4+1 put: 16rCD. "CAPITAL O WITH CIRCUMFLEX"
	d at: 16rD5+1 put: 16rCD.
	d at: 16rD6+1 put: 16r85.
	d at: 16rD7+1 put: 16r2B. "MULTIPLICATION SIGN"
	d at: 16rD8+1 put: 16rBF.
	d at: 16rD9+1 put: 16r86. "CAPITAL U WITH GRAVE"
	d at: 16rDA+1 put: 16r86. "CAPITAL U WITH ACUTE"
	d at: 16rDB+1 put: 16r86. "CAPITAL U WITH CIRCUMFLEX"
	d at: 16rDC+1 put: 16r86. "CAPTIAL U WITH DIAERESIS"
	d at: 16rDD+1 put: 16r59. "CAPITAL Y WITH ACUTE"
	d at: 16rDE+1 put: 16r50. "CAPITAL THORN"
	d at: 16rDF+1 put: 16rA7.
	d at: 16rE0+1 put: 16r88.
	d at: 16rE1+1 put: 16r87.
	d at: 16rE2+1 put: 16r89.
	d at: 16rE3+1 put: 16r8B.
	d at: 16rE4+1 put: 16r8A.
	d at: 16rE5+1 put: 16r8C.
	d at: 16rE6+1 put: 16rBE.
	d at: 16rE7+1 put: 16r8D.
	d at: 16rE8+1 put: 16r8F.
	d at: 16rE9+1 put: 16r8E.
	d at: 16rEA+1 put: 16r90.
	d at: 16rEB+1 put: 16r91.
	d at: 16rEC+1 put: 16r93.
	d at: 16rED+1 put: 16r92.
	d at: 16rEE+1 put: 16r94.
	d at: 16rEF+1 put: 16r95.
	d at: 16rF0+1 put: 16r64. "SMALL ETH"
	d at: 16rF1+1 put: 16r96.
	d at: 16rF2+1 put: 16r98.
	d at: 16rF3+1 put: 16r97.
	d at: 16rF4+1 put: 16r99.
	d at: 16rF5+1 put: 16r9B.
	d at: 16rF6+1 put: 16r9A.
	d at: 16rF7+1 put: 16r2D. "DIVISION SIGN"
	d at: 16rF8+1 put: 16rBF.
	d at: 16rF9+1 put: 16r9D.
	d at: 16rFA+1 put: 16r9C.
	d at: 16rFB+1 put: 16r9E.
	d at: 16rFC+1 put: 16r9F.
	d at: 16rFD+1 put: 16rD8. "SMALL Y WITH ACUTE"
	d at: 16rFE+1 put: 16r70. "SMALL THORN"
	d at: 16rFF+1 put: 16rD8.

	MappingTable := d.
! !

!StrikeFontFixer class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
initializeNoFontTable

	| n |
	n := #(
	16rA4 "CURRENCY SIGN"
	16rA6 "BROKEN BAR"
	16rA8 "DIAERESIS"
	16rAC "NOT SIGN"
	16rAF "MACRON"
	16rB1 "PLUS-MINUS SIGN"
	16rB2 "SUPERSCRIPT TWO"
	16rB3 "SUPERSCRIPT THREE"
	16rB5 "MICRO SIGN"
	16rB8 "CEDILLA"
	16rB9 "SUPERSCRIPT ONE"
	16rBC "VULGAR FRACTION ONE QUARTER"
	16rBD "VULGAR FRACTIOIN ONE HALF"
	16rBE "VALGAR FRACTION THREE QUARTERS"
	16rC1 "CAPITAL A WITH ACUTE"
	16rC2 "CAPITAL A WITH CIRCUMFLEX"
	16rC8 "CAPITAL E WITH GRAVE"
	16rCA "CAPITAL E WITH CIRCUMFLEX"
	16rCB "CAPITAL E WITH DIAERESIS"
	16rCC "CAPITAL I WITH GRAVE"
	16rCD "CAPITAL I WITH ACUTE"
	16rCE "CAPITAL I WITH CIRCUMFLEX"
	16rCF "CAPITAL I WITH DIAERESIS"
	16rD0 "CAPITAL ETH"
	16rD2 "CAPITAL O WITH GRAVE"
	16rD3 "CAPITAL O WITH ACUTE"
	16rD4 "CAPITAL O WITH CIRCUMFLEX"
	16rD7 "MULTIPLICATION SIGN"
	16rD9 "CAPITAL U WITH GRAVE"
	16rDA "CAPITAL U WITH ACUTE"
	16rDB "CAPITAL U WITH CIRCUMFLEX"
	16rDD "CAPITAL Y WITH ACUTE"
	16rDE "CAPITAL THORN"
	16rF0 "SMALL ETH"
	16rF7 "DIVISION SIGN"
	16rFD "SMALL Y WITH ACUTE"
	16rFE "SMALL THORN"
	).
	NoFontTable := n.

! !

!StrikeFontFixer class methodsFor: 'as yet unclassified' stamp: 'nk 7/30/2004 18:09'!
newOn: aStrikeFont 
	^self new  font: aStrikeFont! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:12'!
characterFormAt: aCharacter at: aPoint

	| f |
	f := charForms at: aCharacter asciiValue + 1.
	(f magnifyBy: 3) displayAt: aPoint.
	^ f.
! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:13'!
displayOn: aDisplayObject at: aPoint magnifyBy: aNumber

	| form hStep vStep bb source nextPoint |
	hStep := (strikeFont maxWidth * aNumber * 1.2) asInteger.
	vStep := (strikeFont height * aNumber *  1.2) asInteger.
	
	form := Form extent: (hStep * 16)@(vStep * 16).
	bb := BitBlt toForm: form.
	0 to: 15 do: [:i |
		1 to: 16 do: [:j |
			source := ((charForms at: (i * 16 + j)) magnifyBy: aNumber).
			nextPoint := (hStep * (j - 1)@(vStep * i)).
			bb copy: ((nextPoint+((hStep@vStep - source extent) // 2)) extent: source extent)
				from: 0@0 in: source fillColor: Color black rule: Form over.
		].
	].
	form displayOn: aDisplayObject at: aPoint.
! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:13'!
font: aStrikeFont

	strikeFont := aStrikeFont.
	self forms.
! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'yo 9/16/2002 15:04'!
forms

	1 to: 256 do: [:i |
		charForms at: i put: (strikeFont characterFormAt: (Character value: (i - 1)))
	].
! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'alain.plantec 5/28/2009 11:06'!
initialize

	super initialize.
	charForms := Array new: 256.
! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'yo 9/16/2002 15:04'!
mappingTable

	^ MappingTable.
! !

!StrikeFontFixer methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
storeEditedGlyphsOn: aStream

	
	NoFontTable do: [:i | | n |
		n := strikeFont name.
		(n beginsWith: 'NewYork') ifTrue: [n := 'NewYork'].
		aStream nextPutAll: '((StrikeFont familyName: ''', n, ''' size: ',
			strikeFont height asString, ')'.
		aStream nextPutAll: ' characterFormAt: '.
		aStream nextPutAll: '(Character value: ', i asString, ')'.
		aStream nextPutAll: ' put: '.
		(strikeFont characterFormAt: (Character value: i)) storeOn: aStream base: 2.
		aStream nextPutAll: ')!!'.
		aStream nextPut: Character cr.
		aStream nextPut: Character cr.
	].
! !

Object subclass: #XTableForFixedFont
	instanceVariableNames: 'width maxCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!XTableForFixedFont methodsFor: 'as yet unclassified' stamp: 'yo 8/28/2002 16:14'!
at: anInteger

	(anInteger < 1 or: [maxCode + 2 < anInteger]) ifTrue: [
		self error: 'subscript out of bounds'.
	].
	^(anInteger - 1) * width.
! !

!XTableForFixedFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
maxAscii: anInteger

	maxCode := anInteger.
! !

!XTableForFixedFont methodsFor: 'as yet unclassified' stamp: 'yo 8/28/2002 16:14'!
maxCode

	^ maxCode.
! !

!XTableForFixedFont methodsFor: 'as yet unclassified' stamp: 'yo 8/28/2002 16:14'!
size

	^ maxCode.
! !

!XTableForFixedFont methodsFor: 'as yet unclassified' stamp: 'yo 8/28/2002 16:15'!
width

	^ width.
! !

!XTableForFixedFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
width: anInteger

	width := anInteger.
! !

Object subclass: #XTableForUnicodeFont
	instanceVariableNames: 'ranges xTables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Display'!

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
at: indexPlusOne

	| index |
	index := indexPlusOne.
	ranges with: xTables do: [:range :xTable |
		(range first <= index and: [index <= range last]) ifTrue: [
			^ xTable at: index - range first + 1.
		].
	].
	^ 0.
! !

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/6/2010 08:52'!
at: index put: value

	ranges with: xTables do: [:range :xTable |
		(range first <= index and: [index <= range last]) ifTrue: [
			^ xTable at: index - range first + 1 put: value]].
	^ 0.
! !

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:20'!
ranges: pairArray

	xTables := Array new: 0.
	pairArray do: [:range |
		xTables := xTables copyWith: (Array new: range last - range first + 1 withAll: 0).
	].
	ranges := pairArray.
! !

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'yo 12/29/2002 00:04'!
size

	^ ranges last last - ranges first first + 1.
! !
TTCFontDescription initialize!
StrikeFontFixer initialize!
TTCFont initialize!
TTCFontSet initialize!
